"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createCjsModuleSystem = void 0;
const resolve_1 = require("@file-services/resolve");
const base_cjs_module_system_js_1 = require("./base-cjs-module-system.js");
function createCjsModuleSystem(options) {
    const { fs, globals } = options;
    const { dirname, readFileSync } = fs;
    const { resolver = (0, resolve_1.createRequestResolver)({ fs }), loadModuleHook } = options;
    return (0, base_cjs_module_system_js_1.createBaseCjsModuleSystem)({
        resolveFrom: (contextPath, request, requestOrigin) => resolver(contextPath, request, requestOrigin).resolvedFile,
        readFileSync: (filePath) => readFileSync(filePath, 'utf8'),
        dirname,
        globals,
        loadModuleHook,
    });
}
exports.createCjsModuleSystem = createCjsModuleSystem;
//# sourceMappingURL=cjs-module-system.js.map