"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadStylableConfig = void 0;
const find_config_1 = __importDefault(require("find-config"));
function loadStylableConfig(context, extract) {
    var _a;
    const path = (_a = (0, find_config_1.default)('stylable.config.js', { cwd: context })) !== null && _a !== void 0 ? _a : (0, find_config_1.default)('stylable.config.cjs', { cwd: context });
    let config;
    if (path) {
        try {
            config = require(path);
        }
        catch (e) {
            throw new Error(`Failed to load "stylable.config.js" from ${path}\n${e === null || e === void 0 ? void 0 : e.stack}`);
        }
        if (!config) {
            throw new Error(`Stylable configuration loaded from ${path} but no exported configuration found`);
        }
        return {
            path,
            config: extract(config),
        };
    }
    return undefined;
}
exports.loadStylableConfig = loadStylableConfig;
//# sourceMappingURL=load-stylable-config.js.map