"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.processUrlDependencies = void 0;
const index_internal_1 = require("@stylable/core/dist/index-internal");
const process_declaration_functions_1 = require("@stylable/core/dist/process-declaration-functions");
const path_1 = require("path");
function defaultFilter() {
    return true;
}
function processUrlDependencies({ meta, rootContext, filter = defaultFilter, getReplacement = ({ index }) => `__stylable_url_asset_${index}__`, host, }) {
    const importerDir = (0, path_1.dirname)(meta.source);
    const urls = [];
    const onUrl = (node) => {
        const { url } = node;
        if (url && (0, index_internal_1.isAsset)(url) && filter(url, importerDir)) {
            node.stringType = '"';
            delete node.innerSpacingBefore;
            delete node.innerSpacingAfter;
            const absoluteRequest = (0, index_internal_1.makeAbsolute)(host, url, rootContext, importerDir);
            node.url = getReplacement({
                urls,
                url,
                rootContext,
                importerDir,
                absoluteRequest,
                index: urls.length,
            });
            urls.push(absoluteRequest);
        }
    };
    meta.targetAst.walkDecls((node) => {
        (0, process_declaration_functions_1.processDeclarationFunctions)(node, (functionNode) => {
            if (functionNode.type === 'url') {
                onUrl(functionNode);
            }
        }, true);
    });
    return urls;
}
exports.processUrlDependencies = processUrlDependencies;
//# sourceMappingURL=process-url-dependencies.js.map