"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ensureDirectory = exports.normalizeRelative = exports.tryRun = void 0;
const path_1 = require("path");
function tryRun(fn, errorMessage) {
    try {
        return fn();
    }
    catch (e) {
        throw new Error(errorMessage + ': \n' + (e === null || e === void 0 ? void 0 : e.stack));
    }
}
exports.tryRun = tryRun;
function normalizeRelative(p) {
    p = p.replace(/\\/g, '/');
    return p.startsWith('.') ? p : './' + p;
}
exports.normalizeRelative = normalizeRelative;
function ensureDirectory(dir, fs) {
    if (dir === '.' || fs.existsSync(dir)) {
        return;
    }
    try {
        fs.mkdirSync(dir);
    }
    catch (e) {
        const parentDir = (0, path_1.dirname)(dir);
        if (parentDir !== dir) {
            ensureDirectory(parentDir, fs);
            fs.mkdirSync(dir);
        }
    }
}
exports.ensureDirectory = ensureDirectory;
//# sourceMappingURL=build-tools.js.map