"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stImportToAtImport = void 0;
const import_1 = require("@stylable/core/dist/helpers/import");
const stImportToAtImport = ({ ast, diagnostics, postcss }) => {
    let changed = false;
    ast.walkRules((rule) => {
        if (rule.selector === ':import') {
            const importObj = (0, import_1.parsePseudoImport)(rule, '*', diagnostics);
            if (!diagnostics.reports.length) {
                if (ast.last === rule) {
                    ast.raws.semicolon = true;
                }
                rule.replaceWith(postcss.atRule((0, import_1.createAtImportProps)(importObj)));
                changed = true;
            }
        }
    });
    return {
        changed,
    };
};
exports.stImportToAtImport = stImportToAtImport;
//# sourceMappingURL=st-import-to-at-import.js.map