"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateManifest = void 0;
const path_1 = require("path");
const build_tools_1 = require("./build-tools");
function generateManifest(rootDir, filesToBuild, manifestOutputPath, stylable, mode, log, fs) {
    function getBuildNamespace(stylable, filePath) {
        return stylable.fileProcessor.process(filePath).namespace;
    }
    const manifest = [...filesToBuild].reduce((manifest, filePath) => {
        manifest.namespaceMapping[(0, path_1.relative)(rootDir, filePath)] = getBuildNamespace(stylable, filePath);
        return manifest;
    }, {
        namespaceMapping: {},
    });
    log(mode, 'creating manifest file: ');
    (0, build_tools_1.tryRun)(() => (0, build_tools_1.ensureDirectory)((0, path_1.dirname)(manifestOutputPath), fs), `Ensure directory for manifest: ${manifestOutputPath}`);
    (0, build_tools_1.tryRun)(() => fs.writeFileSync(manifestOutputPath, JSON.stringify(manifest)), 'Write Index File Error');
}
exports.generateManifest = generateManifest;
//# sourceMappingURL=generate-manifest.js.map