"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleAssets = void 0;
const build_tools_1 = require("./build-tools");
function handleAssets(assets, rootDir, srcDir, outDir, fs) {
    const generatedAssets = new Set();
    const { dirname, join } = fs;
    for (const originalPath of assets) {
        if (fs.existsSync(originalPath)) {
            const content = fs.readFileSync(originalPath);
            const targetPath = originalPath.replace(join(rootDir, srcDir), join(rootDir, outDir));
            const targetDir = dirname(targetPath);
            (0, build_tools_1.ensureDirectory)(targetDir, fs);
            fs.writeFileSync(targetPath, content);
            generatedAssets.add(targetPath);
        }
    }
    return generatedAssets;
}
exports.handleAssets = handleAssets;
//# sourceMappingURL=handle-assets.js.map