"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAstNodeAt = void 0;
// ToDo check empty file (position 0)
function getAstNodeAt(root, offset) {
    let closestNode = root;
    let offsetInNode = 0;
    root.walk((node) => {
        var _a, _b;
        if (((_a = node.source) === null || _a === void 0 ? void 0 : _a.start) && ((_b = node.source) === null || _b === void 0 ? void 0 : _b.end)) {
            const inNode = node.source.start.offset <= offset && node.source.end.offset + 1 >= offset;
            if (!inNode) {
                // out of node: bailout
                return false;
            }
            closestNode = node;
            offsetInNode = offset - node.source.start.offset;
        }
        return;
    });
    return [closestNode, offsetInNode];
}
exports.getAstNodeAt = getAstNodeAt;
//# sourceMappingURL=ast.js.map