"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stylableModuleFactory = void 0;
const core_1 = require("@stylable/core");
const stylable_js_module_source_1 = require("./stylable-js-module-source");
function stylableModuleFactory(stylableOptions, { runtimePath, runtimeStylesheetId = 'module', injectCSS = true, staticImports = [], moduleType = 'cjs', runtimeId = '0', } = {}) {
    const stylable = new core_1.Stylable(stylableOptions);
    return function stylableToModule(source, path) {
        const { meta, exports } = stylable.transform(stylable.analyze(path, source));
        return (0, stylable_js_module_source_1.generateStylableJSModuleSource)({
            moduleType: moduleType,
            imports: staticImports.map((from) => ({ from })),
            jsExports: exports,
            namespace: meta.namespace,
            runtimeRequest: runtimePath,
            varType: 'var',
        }, {
            id: runtimeStylesheetId === 'module' ? undefined : meta.namespace,
            css: injectCSS ? meta.targetAst.toString() : '',
            depth: -1,
            runtimeId,
        });
    };
}
exports.stylableModuleFactory = stylableModuleFactory;
//# sourceMappingURL=module-factory.js.map