"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bundleServerLibs = exports.applyWebpackConfigStylableExcludes = exports.getReplacementToken = exports.getImports = exports.uniqueFilterMap = exports.staticCSSWith = exports.reportNamespaceCollision = exports.replaceMappedCSSAssetPlaceholders = exports.replaceCSSAssetPlaceholders = exports.provideStylableModules = exports.outputOptionsAwareHashContent = exports.isStylableModule = exports.isSameResourceModule = exports.isLoadedWithKnownAssetLoader = exports.isDependencyOf = exports.isAssetModule = exports.injectLoader = exports.getTopLevelInputFilesystem = exports.getStylableModules = exports.getStylableBuildMeta = exports.getStylableBuildData = exports.getStaticPublicPath = exports.getSortedModules = exports.getOnlyChunk = exports.getFileName = exports.getEntryPointModules = exports.getCSSViewModuleWebpack = exports.findIfStylableModuleUsed = exports.extractFilenameFromAssetModule = exports.extractDataUrlFromAssetModuleSource = exports.emitCSSFile = exports.createStylableResolverCacheMap = exports.createStaticCSS = exports.createOptimizationMapping = exports.createDecacheRequire = exports.createCalcDepthContext = exports.StylableWebpackPlugin = void 0;
var plugin_1 = require("./plugin");
Object.defineProperty(exports, "StylableWebpackPlugin", { enumerable: true, get: function () { return plugin_1.StylableWebpackPlugin; } });
var plugin_utils_1 = require("./plugin-utils");
Object.defineProperty(exports, "createCalcDepthContext", { enumerable: true, get: function () { return plugin_utils_1.createCalcDepthContext; } });
Object.defineProperty(exports, "createDecacheRequire", { enumerable: true, get: function () { return plugin_utils_1.createDecacheRequire; } });
Object.defineProperty(exports, "createOptimizationMapping", { enumerable: true, get: function () { return plugin_utils_1.createOptimizationMapping; } });
Object.defineProperty(exports, "createStaticCSS", { enumerable: true, get: function () { return plugin_utils_1.createStaticCSS; } });
Object.defineProperty(exports, "createStylableResolverCacheMap", { enumerable: true, get: function () { return plugin_utils_1.createStylableResolverCacheMap; } });
Object.defineProperty(exports, "emitCSSFile", { enumerable: true, get: function () { return plugin_utils_1.emitCSSFile; } });
Object.defineProperty(exports, "extractDataUrlFromAssetModuleSource", { enumerable: true, get: function () { return plugin_utils_1.extractDataUrlFromAssetModuleSource; } });
Object.defineProperty(exports, "extractFilenameFromAssetModule", { enumerable: true, get: function () { return plugin_utils_1.extractFilenameFromAssetModule; } });
Object.defineProperty(exports, "findIfStylableModuleUsed", { enumerable: true, get: function () { return plugin_utils_1.findIfStylableModuleUsed; } });
Object.defineProperty(exports, "getCSSViewModuleWebpack", { enumerable: true, get: function () { return plugin_utils_1.getCSSViewModuleWebpack; } });
Object.defineProperty(exports, "getEntryPointModules", { enumerable: true, get: function () { return plugin_utils_1.getEntryPointModules; } });
Object.defineProperty(exports, "getFileName", { enumerable: true, get: function () { return plugin_utils_1.getFileName; } });
Object.defineProperty(exports, "getOnlyChunk", { enumerable: true, get: function () { return plugin_utils_1.getOnlyChunk; } });
Object.defineProperty(exports, "getSortedModules", { enumerable: true, get: function () { return plugin_utils_1.getSortedModules; } });
Object.defineProperty(exports, "getStaticPublicPath", { enumerable: true, get: function () { return plugin_utils_1.getStaticPublicPath; } });
Object.defineProperty(exports, "getStylableBuildData", { enumerable: true, get: function () { return plugin_utils_1.getStylableBuildData; } });
Object.defineProperty(exports, "getStylableBuildMeta", { enumerable: true, get: function () { return plugin_utils_1.getStylableBuildMeta; } });
Object.defineProperty(exports, "getStylableModules", { enumerable: true, get: function () { return plugin_utils_1.getStylableModules; } });
Object.defineProperty(exports, "getTopLevelInputFilesystem", { enumerable: true, get: function () { return plugin_utils_1.getTopLevelInputFilesystem; } });
Object.defineProperty(exports, "injectLoader", { enumerable: true, get: function () { return plugin_utils_1.injectLoader; } });
Object.defineProperty(exports, "isAssetModule", { enumerable: true, get: function () { return plugin_utils_1.isAssetModule; } });
Object.defineProperty(exports, "isDependencyOf", { enumerable: true, get: function () { return plugin_utils_1.isDependencyOf; } });
Object.defineProperty(exports, "isLoadedWithKnownAssetLoader", { enumerable: true, get: function () { return plugin_utils_1.isLoadedWithKnownAssetLoader; } });
Object.defineProperty(exports, "isSameResourceModule", { enumerable: true, get: function () { return plugin_utils_1.isSameResourceModule; } });
Object.defineProperty(exports, "isStylableModule", { enumerable: true, get: function () { return plugin_utils_1.isStylableModule; } });
Object.defineProperty(exports, "outputOptionsAwareHashContent", { enumerable: true, get: function () { return plugin_utils_1.outputOptionsAwareHashContent; } });
Object.defineProperty(exports, "provideStylableModules", { enumerable: true, get: function () { return plugin_utils_1.provideStylableModules; } });
Object.defineProperty(exports, "replaceCSSAssetPlaceholders", { enumerable: true, get: function () { return plugin_utils_1.replaceCSSAssetPlaceholders; } });
Object.defineProperty(exports, "replaceMappedCSSAssetPlaceholders", { enumerable: true, get: function () { return plugin_utils_1.replaceMappedCSSAssetPlaceholders; } });
Object.defineProperty(exports, "reportNamespaceCollision", { enumerable: true, get: function () { return plugin_utils_1.reportNamespaceCollision; } });
Object.defineProperty(exports, "staticCSSWith", { enumerable: true, get: function () { return plugin_utils_1.staticCSSWith; } });
Object.defineProperty(exports, "uniqueFilterMap", { enumerable: true, get: function () { return plugin_utils_1.uniqueFilterMap; } });
var loader_utils_1 = require("./loader-utils");
Object.defineProperty(exports, "getImports", { enumerable: true, get: function () { return loader_utils_1.getImports; } });
Object.defineProperty(exports, "getReplacementToken", { enumerable: true, get: function () { return loader_utils_1.getReplacementToken; } });
var webpack_config_stylable_excludes_1 = require("./webpack-config-stylable-excludes");
Object.defineProperty(exports, "applyWebpackConfigStylableExcludes", { enumerable: true, get: function () { return webpack_config_stylable_excludes_1.applyWebpackConfigStylableExcludes; } });
Object.defineProperty(exports, "bundleServerLibs", { enumerable: true, get: function () { return webpack_config_stylable_excludes_1.bundleServerLibs; } });
var types_1 = require("./types");
//# sourceMappingURL=index.js.map