"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.callHooks = exports.getPluginsWithHooks = void 0;
function getPluginsWithHooks(data, hookName) {
    if (!data.plugins) {
        return [];
    }
    return data.plugins.filter((item) => !!item.key.plugin[hookName]);
}
exports.getPluginsWithHooks = getPluginsWithHooks;
function callHooks(data, hookName, ...props) {
    const plugins = getPluginsWithHooks(data, hookName);
    for (const pluginInfo of plugins) {
        if (pluginInfo.key.plugin[hookName]) {
            pluginInfo.key.plugin[hookName](pluginInfo.props, ...props);
        }
    }
}
exports.callHooks = callHooks;
//# sourceMappingURL=hooks.js.map