"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.values = exports.keys = exports.getValue = exports.get = exports.has = void 0;
const types_1 = require("./types");
function has(obj, key) {
    return (!!obj &&
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        (typeof obj.has === 'function' ? obj.has(key) : key in obj));
}
exports.has = has;
function get(obj, key) {
    if (obj) {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access, @typescript-eslint/no-unsafe-return
        return typeof obj.get === 'function'
            ? obj.get(key)
            : // @ts-expect-error definitely not a map or nullish
                obj[key];
    }
    return;
}
exports.get = get;
function getValue(map, key, errorMessage) {
    // @ts-expect-error hmm
    if (has(map, key)) {
        // @ts-expect-error hmmm
        return get(map, key);
    }
    throw new Error(errorMessage || `Missing map`);
}
exports.getValue = getValue;
function keys(obj) {
    return (0, types_1.isMap)(obj) ? obj.keys() : Object.keys(obj);
}
exports.keys = keys;
function values(obj) {
    return (0, types_1.isMap)(obj) ? obj.values() : Object.values(obj);
}
exports.values = values;
//# sourceMappingURL=maps.js.map