"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toMap = exports.isDefined = exports.isSet = exports.isMap = void 0;
/**
 * Validates s is an instance of Map
 * @returns true if s is a Map
 */
const isMap = (m) => m instanceof Map;
exports.isMap = isMap;
/**
 * Validates s is an instance of Set
 * @returns true if s is a Set
 */
const isSet = (s) => s instanceof Set;
exports.isSet = isSet;
/**
 * Given a value of type Nullable<T>, validates value is T
 * @returns true if value is defined (not null or undefined)
 */
function isDefined(value) {
    return value !== null && value !== undefined;
}
exports.isDefined = isDefined;
/**
 * Coverts and object into a Map
 * @param obj - POJO
 * @returns A map with the same entries as obj
 */
const toMap = (obj) => new Map(Object.entries(obj));
exports.toMap = toMap;
//# sourceMappingURL=types.js.map