/**
 * Validates s is an instance of Map
 * @returns true if s is a Map
 */
export const isMap = (m) => m instanceof Map;
/**
 * Validates s is an instance of Set
 * @returns true if s is a Set
 */
export const isSet = (s) => s instanceof Set;
/**
 * Given a value of type Nullable<T>, validates value is T
 * @returns true if value is defined (not null or undefined)
 */
export function isDefined(value) {
    return value !== null && value !== undefined;
}
/**
 * Coverts and object into a Map
 * @param obj - POJO
 * @returns A map with the same entries as obj
 */
export const toMap = (obj) => new Map(Object.entries(obj));
//# sourceMappingURL=types.js.map