"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reportError = exports.MISSING_CONTEXT_FOR_API_PROXY = exports.SPAWNED_MORE_THEN_ONCE = exports.MISSING_COM_CONTEXT = exports.MISSING_FORWARD_FOR_MESSAGE = exports.MISSING_ENV = exports.CALLBACK_TIMEOUT = exports.UNKNOWN_CALLBACK_ID = exports.ENV_DISCONNECTED = exports.REMOTE_CALL_FAILED = exports.GLOBAL_REF = exports.DUPLICATE_REGISTER = void 0;
const DUPLICATE_REGISTER = (id, type) => `Could not register same id ${id} as ${type}`;
exports.DUPLICATE_REGISTER = DUPLICATE_REGISTER;
const GLOBAL_REF = (id) => `Com with id "${id}" is already running.`;
exports.GLOBAL_REF = GLOBAL_REF;
const REMOTE_CALL_FAILED = (environment, stack) => `Remote call failed in ${environment}${stack ? `\n${stack}` : ''}`;
exports.REMOTE_CALL_FAILED = REMOTE_CALL_FAILED;
const ENV_DISCONNECTED = (environment) => `Remote call failed in ${environment} - environment disconnected`;
exports.ENV_DISCONNECTED = ENV_DISCONNECTED;
const UNKNOWN_CALLBACK_ID = (message) => `Unknown callback id "${message.callbackId}" in message:\n${JSON.stringify(message)}`;
exports.UNKNOWN_CALLBACK_ID = UNKNOWN_CALLBACK_ID;
const CALLBACK_TIMEOUT = (callbackId, hostId, message) => `Callback timeout "${callbackId}" at ${hostId} on message:\n${JSON.stringify(message)}`;
exports.CALLBACK_TIMEOUT = CALLBACK_TIMEOUT;
const MISSING_ENV = (target, environments) => `Destination environment ${target} is not registered. available environments: [${environments.join(', ')}]`;
exports.MISSING_ENV = MISSING_ENV;
const MISSING_FORWARD_FOR_MESSAGE = (message) => `Not implemented forward for ${message.type}`;
exports.MISSING_FORWARD_FOR_MESSAGE = MISSING_FORWARD_FOR_MESSAGE;
const MISSING_COM_CONTEXT = (id, when) => `Missing communication context for "${id}" when ${when}`;
exports.MISSING_COM_CONTEXT = MISSING_COM_CONTEXT;
const SPAWNED_MORE_THEN_ONCE = (id) => `Environment with id ${id} can only spawned once`;
exports.SPAWNED_MORE_THEN_ONCE = SPAWNED_MORE_THEN_ONCE;
const MISSING_CONTEXT_FOR_API_PROXY = (type, remoteServiceId) => `Missing ${type} when trying to get remote service api proxy for ${remoteServiceId}`;
exports.MISSING_CONTEXT_FOR_API_PROXY = MISSING_CONTEXT_FOR_API_PROXY;
function reportError(e) {
    console.error(e);
}
exports.reportError = reportError;
//# sourceMappingURL=errors.js.map