"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiCounter = exports.isIframe = exports.isWindow = exports.isWorkerContext = void 0;
function isWorkerContext(target) {
    return ((typeof Worker !== 'undefined' && target instanceof Worker) ||
        (typeof WorkerGlobalScope !== 'undefined' && target instanceof WorkerGlobalScope));
}
exports.isWorkerContext = isWorkerContext;
function isWindow(win) {
    return typeof Window !== 'undefined' && win instanceof Window;
}
exports.isWindow = isWindow;
function isIframe(iframe) {
    return typeof HTMLIFrameElement !== 'undefined' && iframe instanceof HTMLIFrameElement;
}
exports.isIframe = isIframe;
class MultiCounter {
    constructor() {
        this.ids = {};
    }
    next(ns) {
        this.ids[ns] = this.ids[ns] || 0;
        return `${ns}${this.ids[ns]++}`;
    }
}
exports.MultiCounter = MultiCounter;
//# sourceMappingURL=helpers.js.map