"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseHost = void 0;
class BaseHost {
    constructor() {
        this.name = 'base-host';
        this.parent = undefined;
        this.handlers = new Map();
    }
    addEventListener(name, handler, _capture) {
        const handlers = this.handlers.get(name);
        if (!handlers) {
            this.handlers.set(name, new Set([handler]));
        }
        else {
            handlers.add(handler);
        }
    }
    removeEventListener(name, handler, _capture) {
        const handlers = this.handlers.get(name);
        if (handlers) {
            handlers.delete(handler);
        }
    }
    postMessage(message) {
        this.emitMessageHandlers(message);
    }
    open() {
        const host = new BaseHost();
        host.parent = this;
        return host;
    }
    emitMessageHandlers(message) {
        for (const handler of this.handlers.get('message') || []) {
            handler({ data: message });
        }
    }
}
exports.BaseHost = BaseHost;
//# sourceMappingURL=base-host.js.map