"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeContextualEnv = void 0;
/**
 * TODO: better inference of the return type of the initialzier function
 */
function initializeContextualEnv({ communication, env: { env, environments }, envInitializers, }) {
    const runtimeEnvironmentName = communication.resolvedContexts[env];
    const activeEnvironment = environments.find((contextualEnv) => contextualEnv.env === runtimeEnvironmentName);
    if (!activeEnvironment) {
        throw new Error(`${runtimeEnvironmentName} cannot be found in definition of ${env} environment`);
    }
    if (activeEnvironment.env in envInitializers) {
        const envInitializer = envInitializers[activeEnvironment.env];
        if (!envInitializer) {
            throw new Error(`environment initializer is not set for ${activeEnvironment.env}`);
        }
        return envInitializer({ communication, env: { ...activeEnvironment, env } });
    }
    else {
        throw new Error('error');
    }
}
exports.initializeContextualEnv = initializeContextualEnv;
//# sourceMappingURL=contextual.js.map