"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ipcInitializer = void 0;
const ipcInitializer = async ({ communication, env: { env, endpointType } }) => {
    const instanceId = communication.getEnvironmentInstanceId(env, endpointType);
    const host = communication.getEnvironmentHost(env);
    if (!host) {
        throw new Error(`IPC hosts should be registered and forked before the initializer run`);
    }
    communication.registerMessageHandler(host);
    await communication.envReady(env);
    return {
        id: instanceId,
    };
};
exports.ipcInitializer = ipcInitializer;
//# sourceMappingURL=ipc.js.map