"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.webWorkerInitializer = void 0;
async function webWorkerInitializer({ communication, env: { env, endpointType } }) {
    const isSingleton = endpointType === 'single';
    const instanceId = isSingleton ? env : communication.generateEnvInstanceID(env);
    const webWorker = new Worker(`${communication.getPublicPath()}${env}.webworker.js${location.search}`, {
        name: instanceId,
    });
    communication.registerMessageHandler(webWorker);
    communication.registerEnv(instanceId, webWorker);
    await communication.envReady(instanceId);
    return {
        id: instanceId,
    };
}
exports.webWorkerInitializer = webWorkerInitializer;
//# sourceMappingURL=webworker.js.map