"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.windowInitializer = void 0;
const helpers_1 = require("../helpers");
const helpers_2 = require("../../helpers");
async function windowInitializer({ communication, env: { env, endpointType }, host }) {
    const instanceId = communication.getEnvironmentInstanceId(env, endpointType);
    const win = (0, helpers_1.isIframe)(host) ? host.contentWindow : host;
    if (!win) {
        throw new Error('cannot spawn detached iframe.');
    }
    await (0, helpers_2.injectScript)(win, instanceId, `${communication.getPublicPath()}${env}.web.js${location.search}`);
    return {
        id: instanceId,
    };
}
exports.windowInitializer = windowInitializer;
//# sourceMappingURL=window.js.map