"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.multiTenantMethod = void 0;
function multiTenantMethod(method) {
    return (context) => {
        function getArgs([_first, ...rest]) {
            return rest;
        }
        function proxyFunction(...args) {
            if (typeof method === 'function') {
                return method.call(context, ...args);
            }
            throw new Error('No Such function');
        }
        return {
            getArgs,
            proxyFunction,
        };
    };
}
exports.multiTenantMethod = multiTenantMethod;
//# sourceMappingURL=service-config.js.map