"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Config = void 0;
const symbols_1 = require("../symbols");
const env_1 = require("./env");
const input_1 = require("./input");
class Config extends input_1.FeatureInput {
    static withType() {
        return {
            defineEntity(defaultValue, mergeConfig, visibleAt) {
                return new Config(defaultValue, mergeConfig, visibleAt);
            },
        };
    }
    constructor(defaultValue, mergeConfig = (a, b) => ({ ...a, ...b }), visibleAt = env_1.AllEnvironments) {
        super(env_1.AllEnvironments, visibleAt);
        this.defaultValue = defaultValue;
        this.mergeConfig = mergeConfig;
        this[_a] = true;
    }
    [(_a = symbols_1.CONFIGURABLE, symbols_1.CREATE_RUNTIME)](context, featureID, entityKey) {
        const topConfig = context.getTopLevelConfig(featureID, entityKey);
        return topConfig.reduce((current, next) => {
            return this.mergeConfig(current, next);
        }, this.defaultValue);
    }
    [symbols_1.REGISTER_VALUE](_context, _providedValue, inputValue, _featureID, _entityKey) {
        return inputValue;
    }
}
exports.Config = Config;
//# sourceMappingURL=config.js.map