"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.serializeError = void 0;
function serializeError(error) {
    if (error instanceof Error) {
        return {
            // Custom properties
            ...error,
            // Non-enumerable properties, can't be added via spread
            name: error.name,
            message: error.message,
            stack: error.stack,
        };
    }
    return {
        name: 'Error',
        message: typeof error === 'string' ? error : JSON.stringify(error),
    };
}
exports.serializeError = serializeError;
//# sourceMappingURL=serialize-error.js.map