"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ElectronBrowserHost = void 0;
const engine_core_1 = require("@wixc3/engine-core");
/**
 * Communication host for the electron-main process
 */
class ElectronBrowserHost extends engine_core_1.BaseHost {
    constructor(host, webContents) {
        super();
        this.host = host;
        this.webContents = webContents;
        this.onMessage = (_, data) => {
            this.emitMessageHandlers(data);
        };
        this.host.on('message', this.onMessage);
    }
    postMessage(message) {
        this.webContents.send('message', message);
    }
    dispose() {
        this.host.off('message', this.onMessage);
    }
}
exports.ElectronBrowserHost = ElectronBrowserHost;
//# sourceMappingURL=electron-node-host.js.map