"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeNodeEnvironmentInBrowser = void 0;
const electron_1 = require("electron");
const engine_electron_commons_1 = require("@wixc3/engine-electron-commons");
/**
 * Spawn a node-based environment from the renderer process.
 * Should be invoked *only* from the renderer process.
 */
const initializeNodeEnvironmentInBrowser = async ({ communication, env, environmentStartupOptions, processOptions }) => {
    const runtimeArguments = await getApplicationMetaData();
    const { id, dispose, onDisconnect, environmentIsReady } = (0, engine_electron_commons_1.initializeNodeEnvironment)({
        environmentStartupOptions,
        env,
        communication,
        runtimeArguments,
        processOptions,
    });
    window.addEventListener('beforeunload', dispose);
    await environmentIsReady;
    return { id, onDisconnect };
};
exports.initializeNodeEnvironmentInBrowser = initializeNodeEnvironmentInBrowser;
async function getApplicationMetaData() {
    return electron_1.ipcRenderer.invoke(engine_electron_commons_1.communicationChannels.engineRuntimeArguments);
}
//# sourceMappingURL=electron-node.js.map