"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ForkedProcess = void 0;
class ForkedProcess {
    constructor(proc) {
        this.proc = proc;
    }
    on(event, handler) {
        this.proc.on(event, handler);
    }
    off(event, handler) {
        this.proc.off(event, handler);
    }
    postMessage(message) {
        if (this.proc.send) {
            this.proc.send(message);
        }
    }
    terminate() {
        this.proc.removeAllListeners();
    }
}
exports.ForkedProcess = ForkedProcess;
//# sourceMappingURL=forked-process.js.map