"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.modalAbsolutePosition = exports.modalAbsolutePositionAsString = void 0;
var Position;
(function (Position) {
    Position["topLeft"] = "topLeft";
    Position["top"] = "top";
    Position["topRight"] = "topRight";
    Position["left"] = "left";
    Position["center"] = "center";
    Position["right"] = "right";
    Position["bottomLeft"] = "bottomLeft";
    Position["bottom"] = "bottom";
    Position["bottomRight"] = "bottomRight";
})(Position || (Position = {}));
function modalAbsolutePositionAsString(position) {
    const style = modalAbsolutePosition(position);
    return Object.entries(style).reduce((agg, [dec, val]) => {
        agg += dec + `:` + val + `;`;
        return agg;
    }, ``);
}
exports.modalAbsolutePositionAsString = modalAbsolutePositionAsString;
function modalAbsolutePosition(position) {
    const alignStyle = { position: `absolute` };
    if (position === Position.center) {
        alignStyle.top = `50%`;
        alignStyle.left = `50%`;
        alignStyle.transform = `translate(-50%, -50%)`;
        return alignStyle;
    }
    switch (position // y
    ) {
        case Position.right:
        case Position.left:
            alignStyle.top = `50%`;
            alignStyle.transform = `translateY(-50%)`;
            break;
        case Position.top:
        case Position.topRight:
        case Position.topLeft:
            alignStyle.top = 0;
            break;
        case Position.bottom:
        case Position.bottomRight:
        case Position.bottomLeft:
            alignStyle.bottom = 0;
    }
    switch (position // x
    ) {
        case Position.top:
        case Position.bottom:
            alignStyle.left = `50%`;
            alignStyle.transform = `translateX(-50%)`;
            break;
        case Position.right:
        case Position.topRight:
        case Position.bottomRight:
            alignStyle.right = 0;
            break;
        case Position.left:
        case Position.topLeft:
        case Position.bottomLeft:
            alignStyle.left = 0;
    }
    return alignStyle;
}
exports.modalAbsolutePosition = modalAbsolutePosition;
//# sourceMappingURL=modal-position.js.map