"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Modal = void 0;
const layer_1 = require("./layer");
const browser_1 = require("@zeejs/browser");
const react_1 = __importDefault(require("react"));
const Modal = ({ children, className, style, backdrop = `block`, position = `center`, show = true, onClickOutside, onFocusChange, onMouseIntersection, onEscape, }) => {
    const alignStyle = (0, browser_1.modalAbsolutePosition)(position);
    const wrapperStyle = style ? { ...style, ...alignStyle } : alignStyle;
    return show ? (react_1.default.createElement(layer_1.Layer, { overlap: "window", backdrop: backdrop, onClickOutside: onClickOutside, onFocusChange: onFocusChange, onMouseIntersection: onMouseIntersection, onEscape: onEscape },
        react_1.default.createElement("div", { className: className, style: wrapperStyle }, children))) : null;
};
exports.Modal = Modal;
//# sourceMappingURL=modal.js.map