"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Popover = void 0;
const layer_1 = require("./layer");
const browser_1 = require("@zeejs/browser");
const react_1 = __importStar(require("react"));
const Popover = ({ children, className, style, show = true, positionX = 'center', positionY = 'after', avoidAnchor = false, matchWidth = false, matchHeight = false, backdrop = `none`, onDisplayChange = noop, onClickOutside, ignoreAnchorClick, onFocusChange, onMouseIntersection, onEscape, }) => {
    const placeholderRef = (0, react_1.useRef)(null);
    const overlayRef = (0, react_1.useRef)(null);
    const { open, close, isOpen, updateOptions } = (0, react_1.useMemo)(() => (0, browser_1.popover)(), []);
    // close on unmount
    (0, react_1.useEffect)(() => () => {
        if (isOpen()) {
            close();
            onDisplayChange(false);
        }
    }, []);
    // open/close or update options
    (0, react_1.useEffect)(() => {
        var _a;
        const anchor = (_a = placeholderRef.current) === null || _a === void 0 ? void 0 : _a.parentElement;
        const overlay = overlayRef.current;
        const opened = isOpen();
        if (opened && !show) {
            close();
            onDisplayChange(false);
        }
        if (show && anchor && overlay) {
            const options = {
                positionX,
                positionY,
                avoidAnchor,
                matchWidth,
                matchHeight,
            };
            if (opened) {
                updateOptions(options);
            }
            else {
                open({
                    anchor,
                    overlay,
                }, options);
                onDisplayChange(true);
            }
        }
    }, [show, positionX, positionY, avoidAnchor, matchWidth, matchHeight]);
    const onClickOutsideWrap = (0, react_1.useCallback)((target) => {
        var _a;
        const anchor = (_a = placeholderRef.current) === null || _a === void 0 ? void 0 : _a.parentElement;
        // ignore click-outside in case there is no handler or
        // in case `ignoreAnchorClick=true` and the target is within
        // the opening anchor
        if (!onClickOutside ||
            (ignoreAnchorClick &&
                anchor &&
                (target === anchor ||
                    (target instanceof Node &&
                        target.compareDocumentPosition(anchor) &
                            anchor.DOCUMENT_POSITION_CONTAINS)))) {
            return;
        }
        onClickOutside(target);
    }, [onClickOutside, ignoreAnchorClick]);
    // ToDo: pass ref to layer - remove extra span
    return (react_1.default.createElement("span", { ref: placeholderRef }, show ? (react_1.default.createElement(layer_1.Layer, { overlap: "window", backdrop: backdrop, onClickOutside: onClickOutsideWrap, onFocusChange: onFocusChange, onMouseIntersection: onMouseIntersection, onEscape: onEscape },
        react_1.default.createElement("div", { ref: overlayRef, className: className, style: style }, children))) : null));
};
exports.Popover = Popover;
const noop = () => {
    /**/
};
//# sourceMappingURL=popover.js.map