"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Root = exports.zeejsContext = void 0;
const browser_1 = require("@zeejs/browser");
const react_1 = __importStar(require("react"));
exports.zeejsContext = (0, react_1.createContext)(null);
const Root = ({ className, style, children }) => {
    const rootRef = (0, react_1.useRef)(null);
    const { rootLayer, parts } = (0, react_1.useMemo)(() => {
        const style = browser_1.isBrowser ? document.createElement(`style`) : { innerText: `` };
        style.innerText = browser_1.css;
        const parts = { style: style, ...(0, browser_1.createBackdropParts)() };
        const rootLayer = (0, browser_1.createRoot)({
            onChange(reason, layer) {
                const wrapper = rootRef.current;
                if (!wrapper) {
                    return;
                }
                const forceFocus = reason === `remove` && layer.state.focusInside;
                // delay blur/re-focus because Layer renders and updates during render
                (0, browser_1.updateLayers)(wrapper, rootLayer, parts, { asyncFocusChange: true, forceFocus });
            },
        });
        return { rootLayer, parts };
    }, []);
    (0, react_1.useEffect)(() => {
        const wrapper = rootRef.current;
        document.head.appendChild(parts.style);
        rootLayer.element = wrapper.firstElementChild;
        const { stop: stopFocus } = (0, browser_1.watchFocus)(wrapper, rootLayer);
        const { stop: stopClickOutside } = (0, browser_1.watchClickOutside)(rootLayer, parts);
        const { stop: stopMouseInside } = (0, browser_1.watchMouseInside)(wrapper, rootLayer, parts);
        const { stop: stopEscape } = (0, browser_1.watchEscape)(rootLayer);
        (0, browser_1.updateLayers)(wrapper, rootLayer, parts);
        () => {
            // ToDo: check why not removed in tests
            document.head.removeChild(parts.style);
            stopFocus();
            stopClickOutside();
            stopMouseInside();
            stopEscape();
        };
    }, []);
    return (react_1.default.createElement("div", { ref: rootRef, className: className, style: style },
        react_1.default.createElement(exports.zeejsContext.Provider, { value: rootLayer },
            react_1.default.createElement("zeejs-layer", null, children))));
};
exports.Root = Root;
//# sourceMappingURL=root.js.map