"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tooltip = void 0;
const layer_1 = require("./layer");
const browser_1 = require("@zeejs/browser");
const react_1 = __importStar(require("react"));
const Tooltip = ({ children, mouseDelay, positionX, positionY }) => {
    const [isOpen, onToggle] = (0, react_1.useState)(false);
    const tooltipLogic = (0, react_1.useMemo)(() => (0, browser_1.tooltip)({
        onToggle,
        mouseDelay,
        isInOverlay: browser_1.isContainedBy,
        positionX,
        positionY,
    }), []);
    const placeholderRef = (0, react_1.useRef)(null);
    const overlayRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(() => {
        var _a;
        const anchor = (_a = placeholderRef.current) === null || _a === void 0 ? void 0 : _a.parentElement;
        if (!anchor) {
            return;
        }
        tooltipLogic.setAnchor(anchor);
        return () => tooltipLogic.stop();
    }, []);
    (0, react_1.useEffect)(() => {
        tooltipLogic.setOverlay(overlayRef.current);
    }, [isOpen, overlayRef.current]);
    (0, react_1.useEffect)(() => {
        tooltipLogic.updatePosition({
            x: positionX,
            y: positionY,
        });
    }, [positionX, positionY]);
    return (react_1.default.createElement("span", { ref: placeholderRef }, isOpen ? (react_1.default.createElement(layer_1.Layer, { onFocusChange: tooltipLogic.flagOverlayFocus, onMouseIntersection: tooltipLogic.flagMouseOverOverlay, onClickOutside: tooltipLogic.flagClickOutside, onEscape: tooltipLogic.onEscape },
        react_1.default.createElement("div", { ref: overlayRef, className: tooltipLogic.initialOverlayCSSClass }, children))) : null));
};
exports.Tooltip = Tooltip;
//# sourceMappingURL=tooltip.js.map