"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutoComplete = void 0;
const react_1 = require("@zeejs/react");
const react_2 = __importStar(require("react"));
const area_1 = require("../area/area");
const common_1 = require("../common");
const use_state_controls_1 = require("../hooks/use-state-controls");
const use_transmitted_events_1 = require("../hooks/use-transmitted-events");
const input_with_clear_1 = require("../input-with-clear/input-with-clear");
const list_1 = require("../list/list");
const scroll_list_1 = require("../scroll-list/scroll-list");
const searchable_text_1 = require("../searchable-text/searchable-text");
const auto_complete_st_css_1 = require("./auto-complete.st.css");
function AutoComplete(props) {
    const { searchControl, getTextContent, items, focusControl, selectionControl, getId, ...listProps } = props;
    const [focused, setFocused] = (0, use_state_controls_1.useStateControls)(focusControl, undefined);
    const [selected, setSelected] = (0, use_state_controls_1.useStateControls)(selectionControl, undefined);
    const inputRef = (0, react_2.useRef)(null);
    const scrollListRef = (0, react_2.useRef)(null);
    const [searchText, updateSearchText] = (0, use_state_controls_1.useStateControls)(searchControl, undefined);
    const { match } = (0, react_2.useContext)(searchable_text_1.searchMethodContext);
    const { cb: onKeyPress, useTransmit } = (0, use_transmitted_events_1.useTransmittedCB)();
    const [isOpen, setIsOpen] = (0, react_2.useState)(false);
    const open = (0, react_2.useCallback)(() => {
        setIsOpen(true);
    }, []);
    const close = (0, react_2.useCallback)(() => {
        setIsOpen(false);
    }, []);
    const filteredData = (0, react_2.useMemo)(() => {
        if (!searchText) {
            return items;
        }
        return items.reduce((acc, item) => {
            const content = getTextContent(item);
            if (match(content, searchText)) {
                acc.push(item);
            }
            return acc;
        }, []);
    }, [getTextContent, items, match, searchText]);
    const onListSelect = (0, react_2.useCallback)((selectedId) => {
        const item = items.find((item) => getId(item) === selectedId);
        updateSearchText(item ? getTextContent(item) : '');
        setSelected(selectedId);
        close();
    }, [close, getId, getTextContent, items, setSelected, updateSearchText]);
    const scrollListRoot = (0, list_1.createListRoot)(area_1.Area, {
        className: auto_complete_st_css_1.classes.scrollListRoot,
        ref: scrollListRef,
        style: {
            height: '100%',
        },
        onMouseDown: common_1.preventDefault,
    });
    const onKeyDown = (0, react_2.useCallback)((ev) => {
        if (ev.code === common_1.KeyCodes.Escape) {
            close();
        }
        else if (ev.code !== common_1.KeyCodes.Tab) {
            open();
            onKeyPress(ev);
        }
    }, [close, onKeyPress, open]);
    (0, react_2.useEffect)(() => {
        if (filteredData[0]) {
            setFocused(getId(filteredData[0]));
        }
    }, [filteredData, getId, setFocused]);
    return (react_2.default.createElement("div", { className: (0, auto_complete_st_css_1.st)(auto_complete_st_css_1.classes.root) },
        react_2.default.createElement(input_with_clear_1.InputWithClear, { valueControl: [searchText || '', updateSearchText], onFocus: open, onBlur: common_1.preventDefault, className: auto_complete_st_css_1.classes.input, onKeyDown: onKeyDown, ref: inputRef }),
        react_2.default.createElement(react_1.Popover, { show: isOpen, matchWidth: true, className: auto_complete_st_css_1.classes.popover, avoidAnchor: true, onClickOutside: close, ignoreAnchorClick: true },
            react_2.default.createElement(searchable_text_1.searchStringContext.Provider, { value: searchText || '' },
                react_2.default.createElement(scroll_list_1.ScrollList, { items: filteredData, ...listProps, scrollListRoot: scrollListRoot, focusControl: [focused, setFocused], selectionControl: [selected, onListSelect], getId: getId, transmitKeyPress: useTransmit, scrollWindow: scrollListRef })))));
}
exports.AutoComplete = AutoComplete;
//# sourceMappingURL=auto-complete.js.map