"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createItems = exports.getChildren = exports.getId = void 0;
const getId = ({ id }) => id;
exports.getId = getId;
const getChildren = (item) => item.children || [];
exports.getChildren = getChildren;
/**
 * Used to generate a list of items for scroll list testing purposes.
 * @param {number} number — number of items to generate;
 * @param {number} startingId — from which id to start; used for infinite scroll testing;
 */
const createItems = (number = 1000, startingId = 0) => new Array(number).fill(0).map((_, id) => ({
    id: 'a' + (id + startingId),
    title: 'item number ' + (id + startingId),
}));
exports.createItems = createItems;
//# sourceMappingURL=items.js.map