"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OverlayRenderer = void 0;
const react_1 = __importStar(require("react"));
const lane_context_1 = require("../../tree-items/lanes/lane-context");
const overlays_renderer_st_css_1 = require("../../tree-items/lanes/overlays-renderer.st.css");
const OverlayRenderer = (props) => {
    const laneCtx = (0, react_1.useContext)(lane_context_1.lanesContext);
    let currPos = 0;
    const lanes = props.shownItems.reduce((acc, item) => {
        var _a, _b;
        const itemSize = (props.itemSizes[item.id] !== undefined ? props.itemSizes[item.id] : props.avgSize) || 0;
        currPos += itemSize;
        if (item.kind !== 'element') {
            acc.set(item, {
                start: currPos,
                end: currPos,
            });
        }
        const parents = laneCtx.getParents(item);
        for (const parent of parents) {
            if (parent.kind !== 'element') {
                acc.set(parent, {
                    start: ((_a = acc.get(parent)) === null || _a === void 0 ? void 0 : _a.start) || 0,
                    end: itemSize + (((_b = acc.get(parent)) === null || _b === void 0 ? void 0 : _b.end) || 0),
                });
            }
        }
        return acc;
    }, new Map());
    return (react_1.default.createElement("div", { className: overlays_renderer_st_css_1.classes.root, style: props.style }, [...lanes.entries()].map(([item, { end, start }]) => {
        var _a;
        const indent = laneCtx.getIndent(item);
        const actualIndent = item.kind !== 'element' ? indent - 1 : indent;
        if (item.kind === 'lane') {
            return (react_1.default.createElement("div", { className: (0, overlays_renderer_st_css_1.st)(overlays_renderer_st_css_1.classes.item, { kind: item.kind }), key: item.id, style: {
                    position: 'absolute',
                    top: start + 'px',
                    height: end - start + 'px',
                    [overlays_renderer_st_css_1.vars.indent]: actualIndent.toString(),
                    [overlays_renderer_st_css_1.vars.laneColor]: item.items[0].color,
                } }));
        }
        if (!((_a = item.children) === null || _a === void 0 ? void 0 : _a.length)) {
            return null;
        }
        return (react_1.default.createElement("div", { className: (0, overlays_renderer_st_css_1.st)(overlays_renderer_st_css_1.classes.item, { kind: item.kind }), key: item.id, style: {
                position: 'absolute',
                top: start - 18 + 'px',
                height: end - start + 18 + 'px',
                [overlays_renderer_st_css_1.vars.indent]: actualIndent.toString(),
            } }));
    })));
};
exports.OverlayRenderer = OverlayRenderer;
//# sourceMappingURL=overlays-renderer.js.map