"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TreeItemRenderer = void 0;
const react_1 = __importDefault(require("react"));
const chevron_right_1 = require("../../icons/wix-ui/chevron-right");
const searchable_text_1 = require("../../searchable-text/searchable-text");
const tree_item_renderer_st_css_1 = require("../tree-items/tree-item-renderer.st.css");
const TreeItemRenderer = (props) => {
    return (react_1.default.createElement("div", { className: (0, tree_item_renderer_st_css_1.st)(tree_item_renderer_st_css_1.classes.root, {
            selected: props.isSelected,
            focused: props.isFocused,
            open: props.isOpen,
        }), style: {
            [tree_item_renderer_st_css_1.vars.indent]: props.indent.toString(),
        }, "data-id": props.id },
        props.hasChildren ? (react_1.default.createElement(chevron_right_1.ChevronRightWixUiIcon, { className: tree_item_renderer_st_css_1.classes.chevron, onClick: () => {
                if (props.isOpen) {
                    props.close();
                }
                else {
                    props.open();
                }
            } })) : null,
        react_1.default.createElement(searchable_text_1.SearchableText, { className: tree_item_renderer_st_css_1.classes.text, text: props.data.title })));
};
exports.TreeItemRenderer = TreeItemRenderer;
//# sourceMappingURL=tree-item-renderer.js.map