"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderInPluginControls = exports.getPluginControls = exports.pluginControlsId = void 0;
const react_1 = __importDefault(require("react"));
const react_dom_1 = __importDefault(require("react-dom"));
const plugin_controls_st_css_1 = require("./plugin-controls.st.css");
exports.pluginControlsId = 'plugin-controls-area';
const getPluginControls = () => {
    let existing = window.document.querySelector('#' + exports.pluginControlsId);
    if (!existing) {
        existing = window.document.createElement('div');
        existing.setAttribute('class', plugin_controls_st_css_1.classes.root);
        existing.setAttribute('id', exports.pluginControlsId);
        window.document.body.appendChild(existing);
    }
    return existing;
};
exports.getPluginControls = getPluginControls;
const renderInPluginControls = (board, pluginControls, key) => {
    const el = (0, exports.getPluginControls)();
    return (react_1.default.createElement(react_1.default.Fragment, null,
        board,
        react_dom_1.default.createPortal(pluginControls, el, key)));
};
exports.renderInPluginControls = renderInPluginControls;
//# sourceMappingURL=plugin-controls.js.map