"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.selectItemByIndex = exports.selectItemButton = exports.selectItemInput = void 0;
const test_utils_1 = __importDefault(require("react-dom/test-utils"));
const scenario_plugin_1 = require("../scenario-plugin");
exports.selectItemInput = 'input';
exports.selectItemButton = 'button';
const selectItemByIndex = (index) => {
    const title = `Select element with index #${index}`;
    return {
        title,
        execute: async () => {
            const input = await (0, scenario_plugin_1.waitForElement)(`#${exports.selectItemInput}`, title);
            if (input && input instanceof HTMLInputElement) {
                input.value = index;
                test_utils_1.default.Simulate.change(input, {
                    target: input,
                });
            }
            const button = await (0, scenario_plugin_1.waitForElement)(`#${exports.selectItemButton}`, title);
            // Needs to happen after ReactTestUtils.Simulate.change would simulate change and board would handle it
            window.setTimeout(() => {
                if (button && button instanceof HTMLButtonElement) {
                    button.click();
                }
            });
        },
        timeout: 2000,
    };
};
exports.selectItemByIndex = selectItemByIndex;
//# sourceMappingURL=select-item-by-index.js.map