"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.themePlugin = exports.ThemeControls = void 0;
const board_core_1 = require("@wixc3/board-core");
const react_1 = __importStar(require("react"));
const plugin_controls_1 = require("../plugin-controls/plugin-controls");
const theme_plugin_st_css_1 = require("./theme-plugin.st.css");
const ThemeControls = ({ themes }) => {
    var _a;
    const [currentValue, updateValue] = (0, react_1.useState)(((_a = themes[0]) === null || _a === void 0 ? void 0 : _a.themeClass) || '');
    (0, react_1.useEffect)(() => {
        const firstTheme = themes[0];
        if (firstTheme) {
            document.body.setAttribute('class', firstTheme.themeClass);
        }
    }, [themes]);
    const onThemeSelect = (0, react_1.useCallback)((ev) => {
        const currValue = ev.currentTarget.value;
        const theme = themes.find((v) => {
            return v.themeTitle === currValue;
        });
        // console.log(theme);
        if (theme) {
            document.body.setAttribute('class', theme.themeClass);
        }
        updateValue(currValue);
    }, [themes]);
    return (react_1.default.createElement("div", { className: theme_plugin_st_css_1.classes.root },
        react_1.default.createElement("div", null, "Themes"),
        react_1.default.createElement("select", { className: theme_plugin_st_css_1.classes.select, value: currentValue, onChange: onThemeSelect }, themes.map((theme) => (react_1.default.createElement("option", { key: theme.themeClass }, theme.themeTitle))))));
};
exports.ThemeControls = ThemeControls;
exports.themePlugin = (0, board_core_1.createPlugin)()('theme', {
    themes: [],
}, {
    wrapRender({ themes }, _r, board) {
        return (0, plugin_controls_1.renderInPluginControls)(board, react_1.default.createElement(exports.ThemeControls, { key: "theme-controls", themes: themes }), 'theme-controls');
    },
});
//# sourceMappingURL=theme-plugin.js.map