"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.childrenById = exports.getElementWithId = void 0;
function getElementWithId(node, scope) {
    let current = node;
    while (current && current !== scope) {
        const id = current.getAttribute('data-id');
        if (id) {
            return { id, element: current };
        }
        current = current.parentElement;
    }
    return null;
}
exports.getElementWithId = getElementWithId;
function childrenById(parent) {
    const children = [];
    for (let i = 0; i < parent.children.length; i++) {
        children.push(parent.children.item(i));
    }
    const res = {};
    children.forEach((el) => {
        const id = el.getAttribute('data-id');
        if (id) {
            res[id] = el;
        }
    });
    return res;
}
exports.childrenById = childrenById;
//# sourceMappingURL=element-id-utils.js.map