"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_board_1 = require("@wixc3/react-board");
const chai_1 = require("chai");
const react_1 = __importDefault(require("react"));
const board_plugins_1 = require("../../../board-plugins");
const scroll_hook_simulator_1 = require("./scroll-hook-simulator");
exports.default = (0, react_board_1.createBoard)({
    Board: () => react_1.default.createElement(scroll_hook_simulator_1.ScrollHookSimulator, null),
    name: 'use scroll window vertical',
    environmentProps: {
        canvasWidth: 200,
        canvasHeight: 2000,
        windowWidth: 500,
        windowHeight: 640,
    },
    plugins: [
        board_plugins_1.scenarioPlugin.use({
            events: [
                (0, board_plugins_1.scrollAction)(300),
                (0, board_plugins_1.expectElementText)('#res', '300'),
                (0, board_plugins_1.scrollAction)(200),
                (0, board_plugins_1.expectElementText)('#res', '200'),
                (0, board_plugins_1.scrollAction)(-1),
                (0, board_plugins_1.expectElement)('#res', (el) => {
                    (0, chai_1.expect)(Math.round(parseFloat(el.innerText))).to.equal(Math.round((0, board_plugins_1.maxScroll)(window, true)));
                }),
                (0, board_plugins_1.scrollAction)(0),
                (0, board_plugins_1.expectElementText)('#res', '0'),
            ],
        }),
    ],
});
//# sourceMappingURL=use-scroll-vertical-window.board.js.map