"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_board_1 = require("@wixc3/react-board");
const chai_1 = require("chai");
const react_1 = __importDefault(require("react"));
const board_plugins_1 = require("../../../board-plugins");
const scroll_hook_simulator_1 = require("./scroll-hook-simulator");
exports.default = (0, react_board_1.createBoard)({
    Board: () => react_1.default.createElement(scroll_hook_simulator_1.ScrollHookSimulator, { useWindowScroll: false }),
    name: 'use scroll vertical with ref',
    environmentProps: {
        canvasWidth: 200,
        canvasHeight: 500,
        windowWidth: 500,
        windowHeight: 640,
    },
    plugins: [
        board_plugins_1.scenarioPlugin.use({
            title: 'should watch scroll position of element',
            events: [
                (0, board_plugins_1.scrollAction)(300, true, '#scroll-div'),
                (0, board_plugins_1.expectElementText)('#res', '300'),
                (0, board_plugins_1.scrollAction)(200, true, '#scroll-div'),
                (0, board_plugins_1.expectElementText)('#res', '200'),
                (0, board_plugins_1.scrollAction)(-1, true, '#scroll-div'),
                (0, board_plugins_1.expectElements)(['#res', '#scroll-div'], (elements) => {
                    (0, chai_1.expect)(Math.round(parseFloat(elements['#res'].innerText))).to.equal(Math.round((0, board_plugins_1.maxScroll)(elements['#scroll-div'], true)));
                }),
                (0, board_plugins_1.scrollAction)(0, true, '#scroll-div'),
            ],
        }),
    ],
});
//# sourceMappingURL=use-scroll-with-ref.board.js.map