"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useElementSize = void 0;
const react_1 = require("react");
const common_1 = require("../common");
const useElementSize = (element, sizeAsHeight) => {
    const [size, updateSize] = (0, react_1.useState)((0, common_1.getElementSize)(element === null || element === void 0 ? void 0 : element.current, sizeAsHeight));
    (0, react_1.useEffect)(() => {
        const cleanup = (element === null || element === void 0 ? void 0 : element.current)
            ? (0, common_1.observeElementDimensions)(element.current, (dimensions) => updateSize((0, common_1.getSizeFromDimensions)(dimensions, sizeAsHeight)))
            : (0, common_1.observeWindowDimensions)((dimensions) => updateSize((0, common_1.getSizeFromDimensions)(dimensions, sizeAsHeight)));
        updateSize((0, common_1.getElementSize)(element === null || element === void 0 ? void 0 : element.current, sizeAsHeight));
        return cleanup;
    }, [element, sizeAsHeight]);
    return size;
};
exports.useElementSize = useElementSize;
//# sourceMappingURL=use-element-size.js.map