"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_board_1 = require("@wixc3/react-board");
const chai_1 = require("chai");
const react_1 = __importStar(require("react"));
const board_assets_1 = require("../../board-assets");
const board_plugins_1 = require("../../board-plugins");
const scroll_list_1 = require("../scroll-list");
const items = (0, board_assets_1.createItems)();
const fixedItemSize = 50; // board-assets/item-renderer/item-renderer.st.css
exports.default = (0, react_board_1.createBoard)({
    name: 'ScrollList — with offset',
    Board: () => {
        const ref = (0, react_1.useRef)(null);
        const [offsetHeight, setOffsetHeight] = (0, react_1.useState)(400);
        return (react_1.default.createElement("div", { style: {
                overflow: 'auto',
                height: '100%',
            }, id: "scroll-root", ref: ref },
            react_1.default.createElement("div", { id: "scroll-element" },
                react_1.default.createElement("div", { style: {
                        height: `${offsetHeight}px`,
                    }, id: "offset" },
                    react_1.default.createElement("input", { value: offsetHeight, type: "number", onChange: (ev) => setOffsetHeight(parseInt(ev.target.value)), id: "input" })),
                react_1.default.createElement(scroll_list_1.ScrollList, { ItemRenderer: board_assets_1.ItemRenderer, items: items, getId: board_assets_1.getId, scrollWindow: ref, itemSize: fixedItemSize, itemGap: 0, scrollOffset: true, listRoot: {
                        el: 'div',
                        props: {
                            style: {
                                width: '100%',
                            },
                        },
                    } }))));
    },
    environmentProps: {
        canvasWidth: 560,
        windowHeight: 726,
        windowWidth: 600,
        canvasHeight: 600,
    },
    plugins: [
        board_plugins_1.scenarioPlugin.use({
            title: 'should listen to offset resize',
            skip: true,
            events: [
                (0, board_plugins_1.expectElements)(['#offset', '[data-id="a0"]'], (els) => {
                    const rootBox = els['#offset'].getBoundingClientRect();
                    const firstItem = els['[data-id="a0"]'].getBoundingClientRect();
                    (0, chai_1.expect)(Math.ceil(firstItem.top)).to.be.equal(Math.ceil(rootBox.bottom));
                }),
                (0, board_plugins_1.expectElement)('#scroll-element', (el) => {
                    (0, chai_1.expect)(el.getBoundingClientRect().height).to.equal(1000 * fixedItemSize + 401);
                }, 'max scroll is accurate', 5000),
                (0, board_plugins_1.scrollAction)(-1, true, '#scroll-root', 4000),
                (0, board_plugins_1.expectElements)(['#scroll-root', '[data-id="a999"]'], (els) => {
                    const rootBox = els['#scroll-root'].getBoundingClientRect();
                    const lastItem = els['[data-id="a999"]'].getBoundingClientRect();
                    (0, chai_1.expect)(Math.ceil(lastItem.bottom)).to.be.approximately(Math.ceil(rootBox.bottom), 2);
                }),
                (0, board_plugins_1.scrollAction)(0, true, '#scroll-root'),
                (0, board_plugins_1.writeAction)('#input', '123'),
                (0, board_plugins_1.expectElement)('#scroll-element', (el) => {
                    (0, chai_1.expect)(el.getBoundingClientRect().height).to.be.approximately(1000 * 100 + 124, 2);
                }, 'max scroll is updated', 5000),
                (0, board_plugins_1.scrollAction)(-1, true, '#scroll-root'),
                (0, board_plugins_1.expectElements)(['#scroll-root', '[data-id="a999"]'], (els) => {
                    const rootBox = els['#scroll-root'].getBoundingClientRect();
                    const lastItem = els['[data-id="a999"]'].getBoundingClientRect();
                    (0, chai_1.expect)(Math.ceil(lastItem.bottom)).to.be.approximately(Math.ceil(rootBox.bottom), 2);
                }),
            ],
        }),
        board_plugins_1.projectThemesPlugin,
    ],
});
//# sourceMappingURL=scroll-offset.board.js.map