"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_board_1 = require("@wixc3/react-board");
const react_1 = __importDefault(require("react"));
const board_assets_1 = require("../../board-assets");
const board_plugins_1 = require("../../board-plugins");
const scroll_list_1 = require("../scroll-list");
const items = (0, board_assets_1.createItems)();
const elementRef = {
    current: null,
};
exports.default = (0, react_board_1.createBoard)({
    name: 'ScrollList — with scroll Ref',
    Board: () => (react_1.default.createElement(scroll_list_1.ScrollList, { ItemRenderer: board_assets_1.ItemRenderer, items: items, getId: board_assets_1.getId, listRoot: {
            el: 'div',
            props: {
                style: {
                    display: 'grid',
                    gridTemplateColumns: '1fr',
                    gridGap: '20px',
                },
            },
        }, scrollListRoot: {
            el: 'div',
            props: {
                id: 'list',
                style: {
                    width: '200px',
                    height: '400px',
                    overflow: 'auto',
                },
                ref: elementRef,
            },
        }, scrollWindow: elementRef, itemGap: 20 })),
    environmentProps: {
        canvasWidth: 560,
        windowHeight: 726,
        windowWidth: 600,
    },
    plugins: [
        board_plugins_1.scenarioPlugin.use({
            title: 'scroll list sanity',
            events: [
                (0, board_plugins_1.expectElement)('[data-id="a3"]'),
                (0, board_plugins_1.hoverAction)('[data-id="a3"]'),
                (0, board_plugins_1.expectElementStyle)('[data-id="a3"]', {
                    backgroundColor: 'rgb(173, 216, 230)',
                }),
                (0, board_plugins_1.hoverAction)('[data-id="a4"]'),
                (0, board_plugins_1.expectElementsStyle)({
                    '[data-id="a3"]': {
                        backgroundColor: 'none',
                    },
                    '[data-id="a4"]': {
                        backgroundColor: 'rgb(173, 216, 230)',
                    },
                }),
                (0, board_plugins_1.clickAction)('[data-id="a4"]'),
                (0, board_plugins_1.expectElementStyle)('[data-id="a4"]', {
                    backgroundColor: 'rgb(173, 216, 230)',
                }),
                (0, board_plugins_1.scrollAction)(-1, true, '#list'),
                (0, board_plugins_1.expectElement)('[data-id="a999"]'),
                (0, board_plugins_1.scrollAction)(0, true, '#list'),
                (0, board_plugins_1.expectElementStyle)('[data-id="a4"]', {
                    backgroundColor: 'rgb(173, 216, 230)',
                }),
            ],
        }),
        board_plugins_1.projectThemesPlugin,
    ],
});
//# sourceMappingURL=scroll-ref.board.js.map