"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getItemSizes = void 0;
const getItemSizes = ({ isHorizontal, items, getId, estimatedItemSize = 50, itemsDimensions, }) => {
    const { totalSize, itemsSizes, measuredItemsNumber } = items.reduce((result, item) => {
        var _a, _b;
        const id = getId(item);
        const size = isHorizontal ? (_a = itemsDimensions[id]) === null || _a === void 0 ? void 0 : _a.width : (_b = itemsDimensions[id]) === null || _b === void 0 ? void 0 : _b.height;
        if (typeof size === 'number') {
            result.totalSize += size;
            result.itemsSizes[id] = size;
            result.measuredItemsNumber++;
        }
        return result;
    }, {
        totalSize: 0,
        itemsSizes: {},
        measuredItemsNumber: 0,
    });
    const averageItemSize = measuredItemsNumber > 0 ? Math.ceil(totalSize / measuredItemsNumber) : estimatedItemSize;
    return {
        itemsSizes,
        averageItemSize,
    };
};
exports.getItemSizes = getItemSizes;
//# sourceMappingURL=get-item-sizes.js.map