"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useLoadMoreOnScroll = void 0;
const react_1 = require("react");
const useLoadMoreOnScroll = ({ loadMore, loadingState, renderSize, lastShownItemIndex, loadedItemsNumber, averageItemSize, }) => {
    (0, react_1.useEffect)(() => {
        if (loadMore && loadingState === 'idle' && lastShownItemIndex > loadedItemsNumber) {
            const itemsToFetchCount = Math.ceil(lastShownItemIndex - loadedItemsNumber + renderSize / averageItemSize);
            if (itemsToFetchCount > 0) {
                loadMore(itemsToFetchCount);
            }
        }
    }, [loadMore, renderSize, loadingState, lastShownItemIndex, loadedItemsNumber, averageItemSize]);
};
exports.useLoadMoreOnScroll = useLoadMoreOnScroll;
//# sourceMappingURL=use-load-more-on-scroll.js.map