"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchableText = exports.searchMethodContext = exports.searchStringContext = exports.splitFuzzySearchText = exports.matchTextFuzzy = void 0;
const react_1 = __importStar(require("react"));
const searchable_text_st_css_1 = require("./searchable-text.st.css");
const matchTextFuzzy = (searchString, inString) => {
    var _a;
    while (searchString.length) {
        const char = searchString[0];
        searchString = searchString.slice(1);
        if ((char === null || char === void 0 ? void 0 : char.toLowerCase()) === ((_a = inString[0]) === null || _a === void 0 ? void 0 : _a.toLowerCase())) {
            inString = inString.slice(1);
            if (inString.length === 0) {
                return true;
            }
        }
    }
    return false;
};
exports.matchTextFuzzy = matchTextFuzzy;
const splitFuzzySearchText = (text, searchString) => {
    var _a;
    let remainingSearchString = searchString;
    let remainingInString = text;
    const sections = [];
    const add = (text, isHighlighted) => {
        var _a;
        if (sections.length === 0 || ((_a = sections[sections.length - 1]) === null || _a === void 0 ? void 0 : _a.isHighlighted) !== isHighlighted) {
            sections.push({
                isHighlighted,
                text,
            });
        }
        else {
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            sections[sections.length - 1].text += text;
        }
    };
    while (remainingSearchString.length && remainingInString.length) {
        const char = remainingSearchString[0];
        if ((char === null || char === void 0 ? void 0 : char.toLowerCase()) == ((_a = remainingInString[0]) === null || _a === void 0 ? void 0 : _a.toLowerCase())) {
            remainingSearchString = remainingSearchString.slice(1);
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            add(remainingInString[0], true);
        }
        else {
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            add(remainingInString[0], false);
        }
        remainingInString = remainingInString.slice(1);
    }
    add(remainingInString, false);
    return sections;
};
exports.splitFuzzySearchText = splitFuzzySearchText;
exports.searchStringContext = (0, react_1.createContext)('');
exports.searchMethodContext = (0, react_1.createContext)({
    match: exports.matchTextFuzzy,
    split: exports.splitFuzzySearchText,
});
const SearchableText = (props) => {
    const searchString = (0, react_1.useContext)(exports.searchStringContext);
    const { split } = (0, react_1.useContext)(exports.searchMethodContext);
    const sections = (0, react_1.useMemo)(() => split(props.text, searchString), [props.text, searchString, split]);
    return (react_1.default.createElement("div", { className: (0, searchable_text_st_css_1.style)(searchable_text_st_css_1.classes.root, props.className) }, sections.map(({ text, isHighlighted }, idx) => {
        return (react_1.default.createElement("span", { key: idx, className: (0, searchable_text_st_css_1.style)(searchable_text_st_css_1.classes.textSpan, { isHighlighted }) }, text));
    })));
};
exports.SearchableText = SearchableText;
//# sourceMappingURL=searchable-text.js.map