"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_board_1 = require("@wixc3/react-board");
const react_1 = __importStar(require("react"));
const board_assets_1 = require("../../board-assets");
const board_plugins_1 = require("../../board-plugins");
const lane_context_1 = require("../../board-assets/tree-items/lanes/lane-context");
const overlays_renderer_1 = require("../../board-assets/tree-items/lanes/overlays-renderer");
const tree_item_with_lane_renderer_1 = require("../../board-assets/tree-items/tree-item-with-lane-renderer");
const tree_1 = require("../tree");
let idCounter = 0;
const nextId = () => 'id' + idCounter++;
const el = (tagName, children) => ({
    id: nextId(),
    kind: 'element',
    tagName,
    children,
});
const laneKinds = {
    repeater: {
        title: 'repeater',
        color: 'blue',
    },
    expression: {
        title: 'expression',
        color: 'orange',
    },
};
const lane = (items, children) => ({
    id: nextId(),
    kind: 'lane',
    items,
    children,
});
const marker = (title, children) => ({
    id: nextId(),
    kind: 'marker',
    title,
    children,
});
const mockedLane = lane([laneKinds.repeater, laneKinds.expression], [
    el('span', [
        el('Comp', [marker('children'), marker('header', [el('div')])]),
        el('div', [
            el('p', [
                lane([laneKinds.repeater], [
                    el('span'),
                    lane([laneKinds.repeater, laneKinds.expression], [
                        lane([laneKinds.repeater, laneKinds.expression], [
                            el('span', [
                                el('Comp', [marker('children'), marker('header', [el('div')])]),
                                el('div', [
                                    el('p', [
                                        lane([laneKinds.repeater], [
                                            el('span'),
                                            lane([laneKinds.repeater, laneKinds.expression], [
                                                lane([laneKinds.repeater, laneKinds.expression], [
                                                    el('span', [
                                                        el('Comp', [
                                                            marker('children'),
                                                            marker('header', [el('div')]),
                                                        ]),
                                                        el('div', [
                                                            el('p', [
                                                                lane([laneKinds.repeater], [el('span')]),
                                                            ]),
                                                        ]),
                                                    ]),
                                                ]),
                                                el('span', [
                                                    el('Comp', [
                                                        marker('children'),
                                                        marker('header', [el('div')]),
                                                    ]),
                                                    el('div', [
                                                        el('p', [
                                                            lane([laneKinds.repeater], [el('span')]),
                                                        ]),
                                                    ]),
                                                ]),
                                            ]),
                                        ]),
                                    ]),
                                ]),
                            ]),
                        ]),
                        el('span', [
                            el('Comp', [marker('children'), marker('header', [el('div')])]),
                            el('div', [el('p', [lane([laneKinds.repeater], [el('span')])])]),
                        ]),
                    ]),
                ]),
            ]),
        ]),
    ]),
]);
const data = el('div', [mockedLane, mockedLane]);
const getAllIds = (item) => item.children ? [item.id, ...item.children.flatMap((item) => getAllIds(item))] : [item.id];
const allIds = getAllIds(data);
const parentMap = new Map();
const addToParentMap = (item) => {
    for (const child of item.children || []) {
        parentMap.set(child, item);
        addToParentMap(child);
    }
};
addToParentMap(data);
const getParents = (item) => {
    let parent = parentMap.get(item);
    const parents = [];
    while (parent) {
        parents.push(parent);
        parent = parentMap.get(parent);
    }
    return parents;
};
const getIndent = (item) => {
    return getParents(item).reduce((acc, curr) => {
        if (curr.kind === 'element') {
            return acc + 1;
        }
        return acc;
    }, 0);
};
const treeOverlay = (0, tree_1.createTreeOverlay)(overlays_renderer_1.OverlayRenderer, {});
exports.default = (0, react_board_1.createBoard)({
    name: 'Tree with lanes',
    Board: () => {
        const [selection, updateSelection] = (0, react_1.useState)(undefined);
        const [openItems, updateOpen] = (0, react_1.useState)(allIds);
        return (react_1.default.createElement(lane_context_1.lanesContext.Provider, { value: (0, react_1.useMemo)(() => ({
                getIndent,
                getParents,
                selectItem: (item) => {
                    updateSelection(item.id);
                },
            }), []) },
            react_1.default.createElement(tree_1.Tree, { ItemRenderer: tree_item_with_lane_renderer_1.TreeItemWithLaneRenderer, data: data, getId: (item) => item.id, getChildren: board_assets_1.getChildren, scrollOffset: 50, openItemsControls: [openItems, updateOpen], selectionControl: [selection, updateSelection], itemSize: tree_item_with_lane_renderer_1.calcItemSize, scrollListRoot: {
                    props: {
                        style: {
                            width: '100%',
                        },
                    },
                }, listRoot: {
                    props: {
                        style: {
                            width: '100%',
                        },
                    },
                }, overlay: treeOverlay })));
    },
    plugins: [board_plugins_1.projectThemesPlugin],
    environmentProps: {
        canvasWidth: 566,
        windowHeight: 600,
        windowWidth: 1024,
    },
});
//# sourceMappingURL=tree-with-lanes.board.js.map