"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_board_1 = require("@wixc3/react-board");
const react_1 = __importStar(require("react"));
const board_assets_1 = require("../../board-assets");
const tree_item_renderer_1 = require("../../board-assets/tree-items/tree-item-renderer");
const board_plugins_1 = require("../../board-plugins");
const tree_1 = require("../tree");
const createTreeData = (maxChildren, maxDepth, currentDepth = 0, path = []) => {
    const item = {
        id: `item_${currentDepth}_${path.toString()}`,
        title: `item_${currentDepth}_${path.toString()}`,
    };
    ids.push(item.id);
    if (currentDepth < maxDepth) {
        const randomNumberOfChildren = Math.floor(Math.random() * (maxChildren + 1));
        const numChildren = currentDepth === 0 ? Math.max(10, randomNumberOfChildren) : randomNumberOfChildren;
        item.children = new Array(numChildren).fill(undefined).map((_, idx) => {
            return createTreeData(maxChildren, maxDepth, currentDepth + 1, [...path, idx]);
        });
    }
    return item;
};
const ids = [];
const treeData = createTreeData(6, 3);
const elementRef = {
    current: null,
};
exports.default = (0, react_board_1.createBoard)({
    name: 'Tree',
    Board: () => {
        const [openItems, setOpenItems] = (0, react_1.useState)(ids);
        return (react_1.default.createElement(tree_1.Tree, { scrollWindow: elementRef, ItemRenderer: tree_item_renderer_1.TreeItemRenderer, data: treeData, getId: board_assets_1.getId, getChildren: board_assets_1.getChildren, itemSize: () => 24, scrollListRoot: {
                el: 'div',
                props: {
                    id: 'list',
                    style: {
                        width: '200px',
                        height: '400px',
                        overflow: 'auto',
                    },
                    ref: elementRef,
                },
            }, openItemsControls: [openItems, setOpenItems] }));
    },
    plugins: [board_plugins_1.projectThemesPlugin],
    environmentProps: {
        windowWidth: 500,
        canvasWidth: 400,
        windowHeight: 575,
        canvasHeight: 525,
    },
});
//# sourceMappingURL=tree.board.js.map