"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.getItems = exports.TreeItemWrapper = exports.Tree = exports.createTreeOverlay = exports.overlayRoot = exports.forwardListOverlay = void 0;
const react_1 = __importStar(require("react"));
const common_1 = require("../common");
const use_element_slot_1 = require("../hooks/use-element-slot");
const use_state_controls_1 = require("../hooks/use-state-controls");
const list_1 = require("../list/list");
const scroll_list_1 = require("../scroll-list/scroll-list");
_a = (0, scroll_list_1.scrollListOverlayParent)(use_element_slot_1.defaultRoot), exports.forwardListOverlay = _a.forward, exports.overlayRoot = _a.slot, exports.createTreeOverlay = _a.create;
function Tree(props) {
    const { listRoot, data, getChildren, openItemsControls, getId, ItemRenderer, focusControl, itemSize, ...scrollListProps } = props;
    const [openItems, updateOpenItems] = (0, use_state_controls_1.useStateControls)(openItemsControls, []);
    const [focused, updateFocused] = (0, use_state_controls_1.useStateControls)(focusControl, undefined);
    const { items, depths } = (0, react_1.useMemo)(() => getItems({ data, getChildren, getId, openItems }), [data, getChildren, getId, openItems]);
    const itemRenderer = (0, react_1.useMemo)(() => TreeItemWrapper(ItemRenderer), [ItemRenderer]);
    const wrapperContext = (0, react_1.useMemo)(() => ({
        open(id) {
            if (!openItems.includes(id)) {
                updateOpenItems([...openItems, id]);
            }
        },
        close(id) {
            if (openItems.includes(id)) {
                updateOpenItems(openItems.filter((item) => item !== id));
            }
        },
        openItems,
        getChildren: getChildren,
        getDepth(id) {
            return depths[id] || 0;
        },
    }), [openItems, getChildren, updateOpenItems, depths]);
    const updatedListRoot = (0, list_1.forwardListRoot)(listRoot, {
        onKeyDown: (0, react_1.useCallback)((ev) => {
            if (ev.code === common_1.KeyCodes.ArrowLeft && focused && openItems.includes(focused)) {
                wrapperContext.close(focused);
            }
            if (ev.code === common_1.KeyCodes.ArrowRight && focused && !openItems.includes(focused)) {
                wrapperContext.open(focused);
            }
        }, [focused, openItems, wrapperContext]),
    });
    const updatedOverlay = (0, exports.forwardListOverlay)(props.overlay, {
        expandedItems: openItems,
    });
    const listItemSize = (0, react_1.useMemo)(() => {
        if (typeof itemSize !== 'function') {
            return itemSize;
        }
        return (info) => {
            const isOpen = openItems.includes(getId(info.data));
            const hasChildren = getChildren(info.data).length > 0;
            return itemSize({
                ...info,
                isOpen,
                hasChildren,
            });
        };
    }, [getChildren, getId, itemSize, openItems]);
    return (react_1.default.createElement(treeWrapperContext.Provider, { value: wrapperContext },
        react_1.default.createElement(scroll_list_1.ScrollList, { ...scrollListProps, overlay: updatedOverlay, getId: getId, items: items, ItemRenderer: itemRenderer, listRoot: updatedListRoot, focusControl: [focused, updateFocused], itemSize: listItemSize })));
}
exports.Tree = Tree;
const treeWrapperContext = (0, react_1.createContext)({
    open: (_id) => {
        //
    },
    close: (_id) => {
        //
    },
    openItems: [],
    getChildren: (_t) => {
        return [];
    },
    getDepth: (_id) => 0,
});
function TreeItemWrapper(UserRenderer) {
    const Wrapper = (props) => {
        const { openItems, close, open, getChildren, getDepth } = (0, react_1.useContext)(treeWrapperContext);
        const boundClose = (0, react_1.useCallback)(() => close(props.id), [close, props.id]);
        const boundOpen = (0, react_1.useCallback)(() => open(props.id), [open, props.id]);
        const hasChildren = getChildren(props.data).length > 0;
        const depth = getDepth(props.id);
        return (react_1.default.createElement(UserRenderer, { ...props, isOpen: openItems.includes(props.id), open: boundOpen, close: boundClose, hasChildren: hasChildren, indent: depth }));
    };
    Wrapper.displayName = 'TreeItemWrapper';
    return Wrapper;
}
exports.TreeItemWrapper = TreeItemWrapper;
function getItems({ data, getId, getChildren, openItems, depth = 0, depths = {}, }) {
    const id = getId(data);
    depths[id] = depth;
    if (!openItems.includes(id)) {
        return {
            items: [data],
            depths,
        };
    }
    return {
        items: [
            data,
            ...getChildren(data).flatMap((item) => getItems({
                data: item,
                getId,
                getChildren,
                openItems,
                depth: depth + 1,
                depths,
            }).items),
        ],
        depths,
    };
}
exports.getItems = getItems;
//# sourceMappingURL=tree.js.map