"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.RendererService=void 0,require("zone.js");const patterns_1=require("@wixc3/patterns"),promise_assist_1=require("promise-assist"),commonjs_1=require("@file-services/commonjs"),universal_1=require("../universal"),window_renderer_1=require("@wixc3/code-execution-feature/window-renderer");var QueueStatus;!function(e){e[e.Active=0]="Active",e[e.NotActive=1]="NotActive"}(QueueStatus||(QueueStatus={}));class RendererService{constructor(e,r,t){this.renderer=e,this.windowController=r,this.modulesToInvalidate=t,this.renderQueue=[],this.queueStatus=QueueStatus.NotActive,this.fileQueueMapping=new Map,this.addedBodyAttributes=new Set,this.renderBoardFactory=(e,r,t)=>async()=>{var n,i;try{const s=this.renderer.getExecutionResource(e),{render:d}=await this.renderer.prepareRender(e,s),{renderable:o}=await d();await new Promise((e=>{requestAnimationFrame((()=>e()))}));const a=this.windowController.getStage();if(null==a||a.updateWindow({...o.environmentProps}),null==a||a.updateCanvas({...o.environmentProps}),RendererService.errors.size)return void t([...RendererService.errors][0]);const u=document.documentElement.innerHTML;r({value:{htmlContents:u,windowWidth:null===(n=o.environmentProps)||void 0===n?void 0:n.windowWidth,windowHeight:null===(i=o.environmentProps)||void 0===i?void 0:i.windowHeight},dependencies:[s]})}catch(e){for(const e of RendererService.newEvaluatedFiles)this.invalidateModule(e);t(RendererService.errors.size?[...RendererService.errors][0]:e)}finally{await this.renderer.cleanup(e),this.cleanup(),this.fileQueueMapping.delete(e)}},this.headObserver=new MutationObserver((e=>{for(const r of e)for(const e of r.addedNodes)RendererService.addedStyleNodes.add(e)})),this.bodyObserver=new MutationObserver((e=>{for(const{attributeName:r}of e)r&&this.addedBodyAttributes.add(r)})),this.headObserver.observe(document.head,{childList:!0,subtree:!1}),this.bodyObserver.observe(document.body,{subtree:!1,attributes:!0})}static async init({createRenderer:e,resolver:r,entries:t,windowController:n,modulesToInvalidate:i=[],projectPath:s}){const d=[],o=await e({entries:t,loadModule:({entryPath:e,moduleSystem:r})=>{let t=this.zoneMapping.get(e);t||(t=Zone.root.fork({name:e,onScheduleTask:(e,r,t,n)=>(this.tasks.add(t.name,n),e.scheduleTask(t,n)),onCancelTask:(e,r,t,n)=>{for(const[r,t]of this.tasks)if(t===n)return this.tasks.delete(r,t),void e.cancelTask(this.zoneMapping.get(r),t);e.cancelTask(t,n)}}),this.zoneMapping.set(e,t));return t.run((()=>{try{return r.requireModule(e)}catch(e){e instanceof Error&&this.errors.add(e)}}))},ensureRenderable:window_renderer_1.getBoardFromModule,loadModuleHook:e=>r=>{d.push(r);try{const t=document.head.children.length,n=e(r);return this.newEvaluatedFiles.add(r),document.head.children.length!==t&&this.filesChangedHead.add(r),n}catch(e){throw e instanceof Error&&this.errors.add(e),e}finally{d.pop()}},excludeEditingTransformers:!1,onModuleSystemReady:e=>(0,window_renderer_1.addReactToWindow)(r,s,e.requireModule)});return new RendererService(o,n,i)}getBoardContents(e){const r=this.fileQueueMapping.get(e);if(r)return r;const{promise:t,resolve:n,reject:i}=(0,promise_assist_1.deferred)();return this.fileQueueMapping.set(e,t),this.renderQueue.push({filePath:e,render:this.renderBoardFactory(e,n,i),cancel:i}),this.queueStatus===QueueStatus.NotActive&&(this.queueStatus=QueueStatus.Active,this.poll()),t}removeBoardFromRenderQueue(e){if(!this.fileQueueMapping.has(e))return;this.fileQueueMapping.delete(e);const r=[];for(const t of this.renderQueue)t.filePath===e?t.cancel("board is removed from render queue"):r.push(t);this.renderQueue=r,0===this.renderQueue.length&&(this.queueStatus=QueueStatus.NotActive)}dispose(){this.renderer.dispose(),this.headObserver.disconnect(),this.bodyObserver.disconnect()}async poll(){for(;this.renderQueue.length;)await this.renderQueue.shift().render();this.queueStatus=QueueStatus.NotActive}invalidateModule(e){return(0,commonjs_1.invalidateModule)(e,this.renderer.moduleSystem.requireCache)}cleanup(){var e;for(const e of RendererService.newEvaluatedFiles)e.includes("node_modules")||this.renderer.moduleSystem.requireCache.delete(e);RendererService.newEvaluatedFiles.clear(),RendererService.errors.clear();for(const e of this.addedBodyAttributes)document.body.removeAttribute(e);this.addedBodyAttributes.clear();for(const e of this.modulesToInvalidate)cleanModuleChildren(this.renderer.moduleSystem.requireCache.get(e),this.renderer.moduleSystem.requireCache);for(const e of RendererService.filesChangedHead)this.invalidateModule(e);RendererService.filesChangedHead.clear();for(const r of RendererService.addedStyleNodes){const t=(0,universal_1.getFilePathFromComment)(null!==(e=r.textContent)&&void 0!==e?e:"");t&&this.invalidateModule(t),document.head.removeChild(r)}RendererService.addedStyleNodes.clear();for(const e of RendererService.tasks.keys()){const r=RendererService.zoneMapping.get(e);if(r){for(const t of RendererService.tasks.get(e))"scheduled"!==t.state&&"running"!==t.state||r.cancelTask(t);RendererService.tasks.deleteKey(e)}}RendererService.tasks.clear();for(const e of RendererService.zoneMapping.keys())this.invalidateModule(e);RendererService.zoneMapping.clear()}}function cleanModuleChildren(e,r){if(e){r.delete(e.id);for(const t of e.children)cleanModuleChildren(t,r)}}exports.RendererService=RendererService,RendererService.addedStyleNodes=new Set,RendererService.filesChangedHead=new Set,RendererService.newEvaluatedFiles=new Set,RendererService.errors=new Set,RendererService.tasks=new patterns_1.SetMultiMap,RendererService.zoneMapping=new Map;