"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ResourceManager=exports.deserializeId=exports.serializeId=void 0;const tslib_1=require("tslib"),types_1=require("./types"),universal_1=require("@wixc3/editor-commons/universal"),cross_performance_1=tslib_1.__importDefault(require("@wixc3/cross-performance")),utils_1=require("./utils");function serializeId(e){return JSON.stringify(null!=e?e:{},Object.keys(null!=e?e:{}).sort())}function deserializeId(e){return JSON.parse(e)}exports.serializeId=serializeId,exports.deserializeId=deserializeId;class ResourceManager{constructor(e,s,t,i,r,a=s,n=[]){this.strategy=e,this.typeName=s,this.syncer=t,this.batcher=i,this.logger=r,this.baseTypeName=a,this.dependenciesBaseTypeName=n,this.listeners=new Set,this.inBatchlisteners=new Set,this.listListeners=new Set,this.openResources=new Map,this.serializeIdsCache=new Map,this.syncerAPI={dispatchChanges:e=>{const s=new Set(e.map((e=>this.openResources.get(e))));for(const e of this.inBatchlisteners)e(s)},get:(e,s)=>this.get(e,s),getResource:e=>this.openResources.get(this.cachedSerializeId(e)),getOpen:()=>this.getOpenResources(),isOpen:e=>this.isOpen(e),onDependencyChange:e=>this.strategy.onDependencyChange?this.strategy.onDependencyChange(this.openResources,e):{recomputedVal:[],recomputedStatus:[]},hasComputeBack:()=>void 0!==this.strategy.onComputeBack,onComputeBack:e=>{var s,t,i;return null!==(i=null===(t=(s=this.strategy).onComputeBack)||void 0===t?void 0:t.call(s,e))&&void 0!==i?i:[]},hasDependenciesToSync:()=>!!this.strategy.dependenciesToSync,dependenciesToSync:e=>this.strategy.dependenciesToSync(e),getMasterSyncerId:()=>this.strategy.getMasterSyncerId(),isLocalChangeAllowed:()=>this.strategy.isLocalChangeAllowed(),remoteInitializeResource:(e,s)=>this.remoteInitializeResource(e,s),onRemoteChanges:(e,s,t,i)=>this.strategy.onRemoteChanges(e,s,t,i),subscribeToOpen:e=>this.subscribeToOpened(e),resourceManager:this},this.isOpen=e=>this.openResources.has(this.cachedSerializeId(e)),this.isProviderOpen=async e=>{if(this.isOpen(e))return!0;const s=this.strategy.getMasterSyncerId();return s!==this.syncer.id&&await this.syncer.isRemoteOpen(this.typeName,e,s)},this.remoteInitializeResource=(e,s)=>{const t=this.strategy.remoteInitializeResource(e,s);return this.onResourceCreated(t).catch(universal_1.reportError),t},this.createResource=(e,s)=>{cross_performance_1.default.mark("createResource");const t=this.strategy.createResource(e);return s&&t.use(s),this.openResources.set(this.cachedSerializeId(e),t),this.onResourceCreated(t).catch(universal_1.reportError),t},this.onResourceCreated=async e=>{this.openResources.set(e.getSerializedId(),e),e.subscribeToDispose(this.disposeResource),e.isReady()||await e.ready,this.dispatchOpenListEvent([e.getSerializedId()])},this.dispatchOpenListEvent=(e=[],s=[])=>{for(const t of this.listListeners)t(e,s)},this.disposeResource=e=>{this.dispatchOpenListEvent([],[e.getSerializedId()]),this.openResources.delete(e.getSerializedId())},this.cachedSerializeId=e=>{const s=this.serializeIdsCache.get(e);if(s)return s;{const s=serializeId(e);return this.serializeIdsCache.set(e,s),s}},this.batcherListerer=e=>{if(e.changed[this.getTypeName()]||e.changedStatus[this.getTypeName()]){const s=this.getResources(e.changed[this.getTypeName()]),t=this.getResources(e.changedStatus[this.getTypeName()]);this.listeners.forEach((e=>e(s,t)))}};const c=this.strategy.getManipulator();t.registerResourceType(s,{manipulator:c,resourceManager:this.getSyncerAPI(),baseTypeName:a,dependenciesBaseTypeName:n})}addDependencyResourceManager(e){this.syncer.addResourceDependency(this,e)}getSyncerAPI(){return this.syncerAPI}getTypeName(){return this.typeName}isResourceOfType(e){return e.getType()===this.getTypeName()}getBatcher(){return this.batcher}get(e,s){let t;return this.isOpen(e)?(t=this.openResources.get(this.cachedSerializeId(e)),s&&t.use(s)):t=this.createResource(e,s),t}getIfReady(e){const s=this.openResources.get(this.cachedSerializeId(e));if(s&&s.isReady())return s}async getReady(e,s){const t=this.get(e,s);return await t.ready,t}getOpenResources(){return[...this.openResources.keys()]}getOpenResourceDeserializedIds(){return[...this.openResources.values()].map((e=>e.getId()))}reEvaluateValue(e){const s=this.openResources.get(this.cachedSerializeId(e));if(s){if(!this.strategy.getValueFromHandler)throw new Error("type strategy does not support invalidation");const t=this.strategy.getValueFromHandler(e,s);(0,utils_1.isPromise)(t)?t.then((e=>{s.isDisposed()||this.setResourceValue(s,e)})).catch(universal_1.reportError):this.setResourceValue(s,t)}}setResourceValue(e,s){const t=e.getLatest();s.value!==t&&(e.applyChange((0,types_1.fullChange)(s.value)),e.setStatus(s.status||{valid:!0}))}subscribeToAny(e){this.subscribeToBatcher(),this.listeners.add(e)}unsubscribeFromAny(e){this.listeners.delete(e)}subscribeToOpened(e){this.listListeners.add(e)}unsubscribeToOpened(e){this.listListeners.delete(e)}subscribeDuringBatch(e){this.inBatchlisteners.add(e)}unsubscribeDuringBatch(e){this.inBatchlisteners.delete(e)}subscribeToBatcher(){this.batcher.subscribe(this.batcherListerer)}getResources(e){return new Set((null==e?void 0:e.map((e=>this.get(deserializeId(e)))))||[])}}exports.ResourceManager=ResourceManager;