"use strict";var _a;Object.defineProperty(exports,"__esModule",{value:!0}),exports.ResourceSyncer=void 0;const syncer_types_1=require("./syncer-types"),promise_assist_1=require("promise-assist"),engine_core_1=require("@wixc3/engine-core"),resource_manager_1=require("./resource-manager"),syncer_utils_1=require("./syncer-utils"),universal_1=require("@wixc3/editor-commons/universal");class ResourceSyncer{constructor(e,s,t,n){this.id=e,this.batcher=s,this.loggerService=n,this[_a]={messageFromRemote:(0,engine_core_1.multiTenantMethod)(this.messageFromRemote)},this.syncers=new Map,this.resources=new Map,this.preDisposalChanges=new Map,this.resourceRemotePromise=new Map,this.rTypesOrder=[],this.resourceConfigs={},this.isCollectingMessages=!1,this.connectionListeners=new Set,this.registrationListeners=new Set,this.subscribeToRemote=(e,s)=>{const t=this.syncers.get(e);if(!t)throw new Error("unknown syncer cannot connnect");const n=s.getType(),r=s.getSerializedId();this.linkResourceToMasterSyncer(e,n,r,s),this.hasCollectedCloseRequestWith(t,n,r)&&t.closeRequests[n].delete(r);const o=this.resourceRemotePromise.get(n);return o.set(r,(0,promise_assist_1.deferred)()),this.updateSyncer(e,{openRequests:{[n]:new Set([r])}}),o.get(r).promise},this.onBatchChange=e=>{e.batchId!==this.runningBatch&&this.reactToLocalChanges(e.changed,e.changedStatus)},this.disposeResource=e=>{var s,t,n;const r=e.getType(),o=e.getSerializedId(),i=this.resourceConfigs[r].resourceManager.getMasterSyncerId(),c=null===(s=this.resources.get(r))||void 0===s?void 0:s.get(o);if(c)for(const s of Object.keys(c.connections)){const t=e.getChangesFromVersion(c.connections[s].snap);this.preDisposalChanges.has(s)||this.preDisposalChanges.set(s,new Map),this.preDisposalChanges.get(s).has(r)||this.preDisposalChanges.get(s).set(r,new Map),this.preDisposalChanges.get(s).get(r).has(o)||this.preDisposalChanges.get(s).get(r).set(o,[]);const n=this.preDisposalChanges.get(s).get(r);n.set(o,n.get(o).concat(t))}null===(t=this.resources.get(r))||void 0===t||t.delete(o);const a=e.results;if(void 0!==a)for(const e of a){const s=e.getSerializedId(),t=e.getType(),r=null===(n=this.resources.get(t))||void 0===n?void 0:n.get(s);r&&e.release(r.connections[i])}i!==this.id&&this.updateSyncer(i,{closeRequests:{[r]:new Set([o])}})};for(const e of Object.keys(t))this.registerResourceType(e,t[e]);s.subscribe(this.onBatchChange)}hasSyncer(e){return this.syncers.has(e)}getRegisteredEnvs(){return[...this.syncers.keys()]}getRegisteredResourceManagers(){return Object.values(this.resourceConfigs).map((e=>e.resourceManager))}addConnectionListener(e){this.connectionListeners.add(e)}removeConnectionListener(e){this.connectionListeners.delete(e)}addRegistartionListener(e){this.registrationListeners.add(e)}removeRegistrationListener(e){this.registrationListeners.delete(e)}registerResourceType(e,s){this.resourceConfigs[e]=s,this.insertInOrder(e,s),this.resources.set(e,new Map),this.resourceRemotePromise.set(e,new Map),s.resourceManager.subscribeToOpen(((e,t)=>{const n=s.resourceManager.getOpen();for(const e of t)n.includes(e)&&this.disposeResource(s.resourceManager.getResource((0,resource_manager_1.deserializeId)(e)))})),this.registrationListeners.forEach((e=>e()))}insertInOrder(e,s){const t=this.rTypesOrder.findIndex((e=>this.resourceConfigs[e].dependenciesBaseTypeName&&this.resourceConfigs[e].dependenciesBaseTypeName.includes(s.baseTypeName)));-1==t?this.rTypesOrder.push(e):this.rTypesOrder.splice(t,0,e)}addResourceDependency(e,s){const t=e.getTypeName(),n=this.resourceConfigs[t];if(!n)throw new Error("Cannot add dependency to unknown ResourceManager");n.dependenciesBaseTypeName.push(s.baseTypeName),this.rTypesOrder.splice(this.rTypesOrder.indexOf(t),1),this.insertInOrder(t,n)}connectSyncer(e,s){this.syncers.has(e)||(this.syncers.set(e,(0,syncer_types_1.createSyncerInfo)(s,!1)),this.connectionListeners.forEach((e=>e())))}disconnectSyncer(e){if(this.syncers.has(e)){for(const[s,t]of this.resources.entries())for(const n of t.keys())this.remoteDisposeRequest(e,s,n);this.syncers.delete(e),this.connectionListeners.forEach((e=>e()))}}get(e,s,t){if(!this.resourceConfigs[e])throw new Error("unknown resource type "+e);return this.resourceConfigs[e].resourceManager.get(s,t)}async getReady(e,s,t){const n=this.get(e,s,t);return await n.ready,n}getOpenResources(e){if(!this.resourceConfigs[e])throw new Error("unknown resource type "+e);return this.resourceConfigs[e].resourceManager.getOpen()}isOpen(e,s){if(!this.resourceConfigs[e])throw new Error("unknown resource type "+e);return this.resourceConfigs[e].resourceManager.isOpen(s)}async isRemoteOpen(e,s,t){const n=this.syncers.get(t);if(!n)throw new Error("unknown syncer cannot query open");return await n.syncer.isOpen(e,s)}hasCollectedCloseRequestWith(e,s,t){var n;return(this.isCollectingMessages||e.isPending)&&(null===(n=e.closeRequests[s])||void 0===n?void 0:n.has(t))}messageFromRemote(e,s,{closeRequests:t,openRequests:n,openRequestsResults:r,changeRequests:o,changesResult:i,pushOpenRequests:c}){this.loggerService.info({value:`message from ${e} to ${this.id}`,metadata:{closeRequests:t,openRequests:n,openRequestsResults:r,changeRequests:o,changesResult:i,pushOpenRequests:c}});let a=!1;const u={},g={},h=(0,syncer_utils_1.resourceMapToIdList)(o,(e=>!!e.changes)),p=(0,syncer_utils_1.resourceMapToIdList)(o,(e=>!!e.newStatus));this.runningBatch=Math.random(),this.startCollectingMessages();const d=this.batcher.batchAll((()=>{var s,t;for(const s of this.rTypesOrder){for(const t of n[s]||[])this.remoteResourceRequest(e,s,t).catch(universal_1.reportError);for(const t of Object.keys(r[s]||[]))this.remoteResourceResponse(e,s,t,r[s][t]);for(const t of Object.keys(c[s]||[]))this.remotePushOpen(e,s,t,c[s][t]);const t=i[s];t&&this.remoteChangeResult(e,s,t);const a=o[s];if(a){this.remoteChangeRequest(e,s,a);for(const s of Object.keys(a)){const{changes:t}=a[s];if(t)for(const s of t){const t=s.removed;if(void 0!==t)for(const s of t)this.get(s.type,s.id).release(this.resources.get(s.type).get(s.serializedId).connections[e])}}}}let d=this.rTypesOrder.length;for(;d--;){const e=this.rTypesOrder[d],n=this.resourceConfigs[e];if(!n.resourceManager.hasComputeBack())continue;const r=[...h[e]||[],...u[e]||[]];for(const i of r)try{const e=n.resourceManager.onComputeBack(n.resourceManager.get((0,resource_manager_1.deserializeId)(i)));for(const{type:s,serializedId:t}of e)a=!0,h[s]||(h[s]=[]),u[s]||(u[s]=[]),h[s].push(t),u[s].push(t)}catch(r){(0,universal_1.reportError)(r);const c=n.resourceManager.getResource((0,resource_manager_1.deserializeId)(i)),a=(null===(t=null===(s=o[e])||void 0===s?void 0:s[i])||void 0===t?void 0:t.changes)||[];c.revertChanges(a)&&this.updateSyncersAfterChanges({[e]:[i]},{})}}const l=(0,syncer_utils_1.mergeIdList)(h,p);if(Object.keys(l).length)for(const e of this.rTypesOrder){const s=this.resourceConfigs[e],{recomputedVal:t,recomputedStatus:n}=s.resourceManager.onDependencyChange(l);t.length&&(a=!0,this.updateNewlyComputed(u,l,e,t)),n.length&&(a=!0,this.updateNewlyComputed(g,l,e,n)),this.callManagerSubscribers(l[e],s)}}),this.runningBatch);for(const s of this.rTypesOrder)for(const n of t[s]||[])this.remoteDisposeRequest(e,s,n);if(this.runningBatch=void 0,"failure"===d.status)throw d.error;a?this.updateSyncersAfterChanges(u,g):this.releaseCollectedMessages()}startCollectingMessages(){this.isCollectingMessages=!0}releaseCollectedMessages(){this.isCollectingMessages=!1;for(const[e,s]of this.syncers.entries())s.isPending||this.updateSyncerIfPending(e)}reactToLocalChanges(e,s){this.runningBatch=Math.random();const t=(0,syncer_utils_1.cloneIdList)(e),n=(0,syncer_utils_1.cloneIdList)(s),r=this.batcher.batchAll((()=>{let e=this.rTypesOrder.length;for(;e--;){const s=this.rTypesOrder[e],n=this.resourceConfigs[s];if(t[s]&&n.resourceManager.hasComputeBack())for(const e of t[s]){const s=n.resourceManager.onComputeBack(n.resourceManager.get((0,resource_manager_1.deserializeId)(e)));for(const e of s)t[e.type]||(t[e.type]=[]),t[e.type].push(e.serializedId)}}const s=(0,syncer_utils_1.mergeIdList)(t,n);for(const e of this.rTypesOrder){const r=this.resourceConfigs[e],{recomputedVal:o,recomputedStatus:i}=r.resourceManager.onDependencyChange(s);o.length&&this.updateNewlyComputed(s,t,e,o),i.length&&this.updateNewlyComputed(s,n,e,i),this.callManagerSubscribers(s[e],r)}}),this.runningBatch);if("failure"===r.status)throw r.error;this.updateSyncersAfterChanges({...r.changed,...t},{...r.changedStatus,...n}),this.runningBatch=void 0}updateNewlyComputed(e,s,t,n){e[t]=(e[t]||[]).concat(n),s[t]=s[t]?s[t].concat(n):n}callManagerSubscribers(e,s){(null==e?void 0:e.length)&&s.resourceManager.dispatchChanges(e)}linkResourceToSlaveSyncer(e,s,t,n){const r=this.resources.get(s);r.get(t)||r.set(t,{connections:{}});const o=r.get(t);if(!o.connections[e]){const s={snap:n.createSnapshot(),approvedSnap:n.createSnapshot(),toMaster:!1,resource:n};n.use(s),o.connections[e]=s}return n}linkResourceToMasterSyncer(e,s,t,n){const r=this.resources.get(s);r.get(t)||r.set(t,{connections:{}});const o=r.get(t);return o.connections[e]||(o.connections[e]={snap:n.createSnapshot(),approvedSnap:n.createSnapshot(),toMaster:!1}),n}async remoteResourceRequest(e,s,t){if(!this.syncers.has(e))throw new Error(`unknown syncer cannot connect to ${e}`);const n=this.get(s,(0,resource_manager_1.deserializeId)(t));let r;this.linkResourceToSlaveSyncer(e,s,t,n);try{await n.ready,r={status:"success",result:{value:n.getLatest(),status:n.getStatus()}}}catch(e){r={status:"failure",reason:e&&e.message?e.message:e.toString()}}this.updateSyncer(e,{openRequestsResult:{[s]:{[t]:r}},pushOpenRequests:this.getDependenciesToUpdate(n,e)})}getDependenciesToUpdate(e,s){var t;const n=e.getType(),r=this.resourceConfigs[n];if(r.resourceManager.hasDependenciesToSync()){const n={};for(const o of r.resourceManager.dependenciesToSync(e)){const e=o.getType(),r=o.getSerializedId(),i=null===(t=this.resources.get(e))||void 0===t?void 0:t.get(r);if(!i||!i.connections[s]){n[e]||(n[e]={});const t={result:{value:o.getLatest(),status:o.getStatus()}};n[e][r]=t,this.linkResourceToSlaveSyncer(s,e,r,o)}}return n}}remoteResourceResponse(e,s,t,n){var r;const o=null===(r=this.resourceRemotePromise.get(s))||void 0===r?void 0:r.get(t);o&&("success"===n.status?o.resolve(n.result):o.reject(n.reason),this.resourceRemotePromise.get(s).delete(t))}remotePushOpen(e,s,t,n){const r=this.resourceConfigs[s];if(!r.resourceManager.isOpen(t)){const o=r.resourceManager.remoteInitializeResource((0,resource_manager_1.deserializeId)(t),n.result);this.linkResourceToMasterSyncer(e,s,t,o),o.use(this.resources.get(s).get(t).connections[e])}}remoteChangeResult(e,s,t){var n;const r=Object.keys(t),o=this.resourceConfigs[s];for(const i of r){const r=null===(n=this.resources.get(s))||void 0===n?void 0:n.get(i);if(!r)continue;const c=o.resourceManager.getResource((0,resource_manager_1.deserializeId)(i)),a=r.connections[e];a&&("success"===t[i].status?a.pendingApproval&&(a.approvedSnap.dispose(),a.approvedSnap=a.pendingApproval,a.pendingApproval=void 0):(a.snap=this.renewSnap(c,a.snap),a.approvedSnap=this.renewSnap(c,a.approvedSnap)))}}remoteChangeRequest(e,s,t){var n;const r=Object.keys(t),o=this.resourceConfigs[s],i={},c={};for(const a of r){const r=null===(n=this.resources.get(s))||void 0===n?void 0:n.get(a);if(!r)continue;const u=o.resourceManager.getResource((0,resource_manager_1.deserializeId)(a)),g=o.resourceManager.onRemoteChanges(e,t[a],u,r),h=!!t[a].newStatus&&!t[a].changes;if(h&&!g.statusChanged)continue;i[a]=g;const p=r.connections[e];p&&(p.snap=this.renewSnap(u,p.snap),p.approvedSnap=this.renewSnap(u,p.approvedSnap));for(const s of Object.keys(r.connections))s!==e&&(c[s]||(c[s]={pendingChanges:new Set,pendingStatusChanges:new Set}),h?c[s].pendingStatusChanges.add(a):c[s].pendingChanges.add(a))}this.updateSyncer(e,{changesResult:{[s]:i}});for(const e of Object.keys(c))this.updateSyncer(e,{pendingChanges:{[s]:c[e].pendingChanges},pendingStatusChanges:{[s]:c[e].pendingStatusChanges}})}renewSnap(e,s){return s.dispose(),e.createSnapshot()}remoteDisposeRequest(e,s,t){var n,r;if(!this.syncers.has(e))return void console.error(`unknown syncer cannot dispose: ${e} ${s} ${t}`);const o=null===(n=this.resources.get(s))||void 0===n?void 0:n.get(t);if(!o)return void console.error(`unknown resource cannot dispose: ${e} ${s} ${t}`);const i=o.connections[e];i&&(delete o.connections[e],null===(r=i.resource)||void 0===r||r.release(i),0===Object.values(o.connections).length&&this.resources.get(s).delete(t))}updateSyncersAfterChanges(e,s){var t,n;this.startCollectingMessages();const r={};for(const o of this.rTypesOrder){const i=e[o];if(null==i?void 0:i.length)for(const e of i){const s=null===(t=this.resources.get(o))||void 0===t?void 0:t.get(e);if(!s)continue;const n=this.resourceConfigs[o].resourceManager.getResource((0,resource_manager_1.deserializeId)(e));for(const e of Object.keys(s.connections)){r[e]=r[e]||{pendingChanges:{},pendingStatusChanges:{},pushOpenRequests:{}},r[e].pendingChanges[o]=new Set(i);const s=this.getDependenciesToUpdate(n,e);s&&(r[e].pushOpenRequests=(0,syncer_utils_1.mergeResourceMaps)(((e,s)=>s),r[e].pushOpenRequests||{},s))}}const c=s[o];if(null==c?void 0:c.length)for(const e of c){const s=null===(n=this.resources.get(o))||void 0===n?void 0:n.get(e);if(s)for(const e of Object.keys(s.connections))r[e]=r[e]||{pendingChanges:{},pendingStatusChanges:{},pushOpenRequests:{}},r[e].pendingStatusChanges[o]=new Set(c)}}for(const e of Object.keys(r))this.updateSyncer(e,r[e]);this.releaseCollectedMessages()}updateSyncerIfPending(e){const s=this.syncers.get(e);if(!s)return;let t=!1;const n={};for(const e of syncer_types_1.pendingSyncerMessageTypes)Object.keys(s[e]).length&&(t=!0,n[e]=s[e]);t&&this.updateSyncer(e,n)}updateSyncer(e,s){var t,n,r;const o=this.syncers.get(e);if(!o)return;if(this.isCollectingMessages||o.isPending){for(const e in s)"pendingChanges"===e||"pendingStatusChanges"===e||"openRequests"===e||"closeRequests"===e?s[e]&&(0,syncer_utils_1.mergeChangeSets)(o[e],s[e]):"openRequestsResult"!==e&&"changesResult"!==e||(o[e]=(0,syncer_utils_1.mergeResourceMaps)(((e,s)=>s),o[e],s[e]));return void(s.pushOpenRequests&&(o.pushOpenRequests=(0,syncer_utils_1.mergeResourceMaps)(((e,s)=>s),o.pushOpenRequests,s.pushOpenRequests)))}const i=(0,syncer_types_1.withDefaultPendingSyncerInfo)(s),c=(0,syncer_types_1.createSyncerInfo)(o.syncer,o.isPending);this.syncers.set(e,c);const a={},u=i.pendingChanges;for(const s of Object.keys(u)){const r=this.resourceConfigs[s];if(r.resourceManager.isLocalChangeAllowed()){a[s]={};for(const n of[...u[s]]){a[s][n]={};const o=null===(t=this.resources.get(s))||void 0===t?void 0:t.get(n);if(o){const t=r.resourceManager.getResource((0,resource_manager_1.deserializeId)(n)),i=o.connections[e];if(i){const e=t.getChangesFromVersion(i.snap);a[s][n].changes=e;const r=t.getManipulator().squasher;void 0!==r&&e.length>1&&(a[s][n].changes=r(e))}}else{const t=this.preDisposalChanges.get(e);if(t){let e=t.get(s).get(n);t.set(s,new Map);const o=r.manipulator.squasher;void 0!==o&&e.length>1&&(e=o(e)),a[s][n].changes=e}}}for(const t of Object.keys(a[s])){const o=null===(n=this.resources.get(s))||void 0===n?void 0:n.get(t);if(!o)continue;const i=r.resourceManager.getResource((0,resource_manager_1.deserializeId)(t)),c=o.connections[e];c&&(c.snap=i.createSnapshot(),c.pendingApproval=i.createSnapshot())}}}const g=i.pendingStatusChanges;for(const e of Object.keys(g)){const s=this.resourceConfigs[e];for(const t of[...g[e]]){const n=s.resourceManager.getResource((0,resource_manager_1.deserializeId)(t));n&&(a[e]||(a[e]={}),(r=a[e])[t]||(r[t]={}),a[e][t].newStatus=n.getStatus())}}let h=!0;if(Object.keys(a).length&&(h=!1),h)for(const e of syncer_types_1.pendingSyncerMessageTypes)if(Object.keys(i[e]).length){h=!1;break}if(h)return c.isPending=!1,void this.updateSyncerIfPending(e);c.isPending=!0,c.syncer.messageFromRemote(this.id,{changeRequests:a,closeRequests:(0,syncer_utils_1.resourceSetToList)(i.closeRequests),openRequests:(0,syncer_utils_1.resourceSetToList)(i.openRequests),openRequestsResults:i.openRequestsResult,changesResult:i.changesResult,pushOpenRequests:i.pushOpenRequests}).finally((()=>{c.isPending=!1,this.updateSyncerIfPending(e)})).catch(universal_1.reportError)}}exports.ResourceSyncer=ResourceSyncer,_a=engine_core_1.SERVICE_CONFIG;