"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.GitService=void 0;const tslib_1=require("tslib"),path_1=require("@file-services/path"),universal_1=require("@wixc3/editor-commons/universal"),universal_2=require("../universal"),git_url_parse_1=tslib_1.__importDefault(require("git-url-parse")),utils_1=require("./utils");class GitService{constructor(t,e,i,a,s,r,n,o,c){this.git=t,this.gitRepoStatusSyncer=a,this.gitEventEmitter=s,this.realPath=r,this.fsSyncer=n,this.fileAssetsResourceManager=o,this.getProjectPath=c,this.isInitialized=!1,this.gitRootFolder=void 0,this.absoluteToRelative=t=>{if(!this.gitRootFolder)throw new Error("Git root folder is not set");return(0,path_1.relative)(this.gitRootFolder,t)},this.gitRepoStatusResource=e.get(universal_2.GIT_REPO_STATUS_RESOURCE_ID,this),this.gitMergeStateResource=i.get(universal_2.GIT_MERGER_STATE_RESOURCE_ID,this),this.init().then((()=>{this.isInitialized=!0}))}async init(){this.gitRootFolder=await(0,utils_1.getGitRootFolder)(this.git,this.realPath)}async getRemoteOriginUrl(){try{return(await this.git.raw(["config","--get","remote.origin.url"])).trim()}catch{return}}async getParsedRemoteOriginUrl(){const t=await this.getRemoteOriginUrl();if(t)return(0,path_1.isAbsolute)(t)?parseLocalGitUrl(t):(0,git_url_parse_1.default)(t)}async getLogEntries(t){return(await this.git.raw(["log",`--format=${t}`])).trim()}undoLastCommit(){return this.git.raw(["reset","HEAD~"])}async undoChanges(t){const e=await this.forceStatusUpdate(),i=new Set(e.staged),a=t.filter((t=>i.has(t))).map(this.absoluteToRelative);await this.git.raw(["reset","HEAD","-q",...a]);const s=t.map(this.absoluteToRelative),r=new Set(this.filterFilesByStatus(e.filesMap,(({modificationStatus:t})=>t===universal_2.GitFileModificationStatus.Added))),n=[],o=[];for(const t of s)r.has(t)?n.push(t):o.push(t);n.length&&await this.cleanUntrackedPaths(n),o.length&&await this.git.raw(["checkout","-q",...o])}async revertAll(){await this.resetHard();const{filesMap:t}=await this.forceStatusUpdate(),e=await this.getUntrackedGitPaths(t);await this.cleanUntrackedPaths(e)}async commitFiles(t,e){const i=await Promise.all(e.map(this.absoluteToRelative)),{filesMap:a}=await this.forceStatusUpdate(),s=new Set(await this.getUntrackedGitPaths(a)),r=i.filter((t=>s.has(t)));r.length&&await this.git.raw(["add","-A",...r]);try{return await this.git.commit(t,i)}catch(t){throw await this.git.raw(["reset","-q","HEAD",...r]),t}}async mergeFrom(t){const e=await this.git.merge([t]);this.gitMergeStateResource.applyPatch((t=>{t.lastMergeResult=e}))}async commitAll(t){const{filesMap:e}=await this.forceStatusUpdate(),i=await this.getUntrackedGitPaths(e);try{return await this.git.raw(["add","-A","."]),await this.git.commit(t)}catch(t){throw await this.git.raw(["reset","-q","HEAD",...i]),t}}async history({limit:t=50,skip:e}={}){const i={"--max-count":t.toString()};return e&&(i["--skip"]=e.toString()),this.git.log(i)}async createNewBranch(t){await this.git.raw(["checkout","-b",t]),this.gitEventEmitter.emit("createBranch",{branchName:t})}async switchBranch(t,e){this.fsSyncer.suspendSyncer();const i=["-q"];if(e){const e=await this.getTrackingLocalBranch(t);e?(await this.git.checkout(e,i),t=e):(i.push("--track"),await this.git.checkout(t,i),t=(await this.git.status()).current,this.gitEventEmitter.emit("createBranch",{branchName:t}))}else await this.git.checkout(t,i);return this.gitEventEmitter.emit("switchBranch",{branchName:t}),setTimeout((()=>{this.fsSyncer.resumeSyncer(),this.fsSyncer.processAccumulatedEvents(),this.fileAssetsResourceManager.reEvaluateValue(this.getProjectPath())}),1e3),t}async getCurrentBranch(){return(await this.git.raw(["rev-parse","--abbrev-ref","HEAD"])).trim()}async pushCurrentBranch(){const t=await this.getCurrentBranch();await this.git.raw(["push","-u","origin",t])}async getTrackingBranch(t){return(await this.git.raw(["for-each-ref","--format","%(upstream:short)",`refs/heads/${t}`])).trim()||void 0}async forceStatusUpdate(){if(!this.gitRepoStatusResource.isValid())throw new Error(this.gitRepoStatusResource.getInvalidationMessage());await Promise.all([new Promise((t=>this.gitRepoStatusResource.subscribeOnce(t))),this.gitRepoStatusSyncer.updateStatus({force:!0})]);const t=this.gitRepoStatusResource.getLatest();if(null===t)throw new Error("GitRepoStatusResource is null after being updated, check GitRepoStatusResourceSyncer");return t}async getFileHeadContent(t){const e=this.absoluteToRelative(t);return this.git.show([`HEAD:${(0,universal_1.replaceWinSlashes)(e)}`])}async getPullRequestType(){const t=await this.getParsedRemoteOriginUrl();if(t)return"github.com"===t.resource?universal_2.PullRequestType.PullRequest:await this.isGitlabInstanceDomain(t.resource)?universal_2.PullRequestType.MergeRequest:void 0}async getNewPullRequestUrl(t){const e=await this.getParsedRemoteOriginUrl();if(!e)return;const i=e.resource,a=e.full_name,s=encodeURIComponent(t);return"github.com"===i?`https://github.com/${a}/compare/${s}?quick_pull=1`:await this.isGitlabInstanceDomain(i)?`https://${i}/${a}/-/merge_requests/new?merge_request%5Bsource_branch%5D=${s}`:void 0}isGitlabInstanceDomain(t){return Promise.resolve(t.includes("gitlab"))}async cleanUntrackedPaths(t){const e=groupByDir(t);await Promise.all(Object.values(e).map((t=>this.git.raw(["clean","-f","-q",...t]))))}async getTrackingLocalBranch(t){const e=(await this.git.raw(["for-each-ref","--format","%(refname:short)::%(upstream:short)","refs/heads"])).trim().split("\n");for(const i of e){const[e,a]=i.split("::");if(a===t)return e}}async resetHard(){await this.git.raw(["reset","HEAD","--hard","-q"])}async getUntrackedGitPaths(t){return Promise.all(this.filterFilesByStatus(t,(t=>!t.tracked)))}filterFilesByStatus(t,e){return Object.entries(t).filter((([,t])=>e(t))).map((([t])=>t)).map(this.absoluteToRelative)}}function groupByDir(t){return t.reduce(((t,e)=>{const i=path_1.win32.dirname(e);return t[i]||(t[i]=new Set),t[i].add(e),t}),{})}function parseLocalGitUrl(t){const e=(0,path_1.basename)(t),i=(0,path_1.dirname)(t);return{name:e,href:t,full_name:t,owner:i,protocol:"file",protocols:["file"],organization:i,resource:"",user:"",pathname:"",hash:"",search:"",token:"",source:"",port:0,ref:"",filepathtype:"",filepath:""}}exports.GitService=GitService;