"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.GitHubAuthService=void 0;const tslib_1=require("tslib"),request_error_1=require("@octokit/request-error"),rest_1=require("@octokit/rest"),universal_1=require("@wixc3/editor-commons/universal"),app_1=tslib_1.__importDefault(require("firebase/compat/app"));require("firebase/compat/auth");const promise_assist_1=require("promise-assist"),feature_1=require("../feature"),github_oauth_scopes_1=require("../universal/github-oauth-scopes"),HTTP_UNAUTHORIZED=401;class GitHubAuthService{constructor(e){this.onAuthStateChange=new universal_1.Signal,this.subscribeToAuthStateChange=this.onAuthStateChange.subscribe,this.unsubscribeFromAuthStateChange=this.onAuthStateChange.unsubscribe,this.firebaseConfig=e.firebaseConfig,this.gitHubUserConfig=e.gitHubUserConfig,this.authFlowServer=e.gitHubAuthFlowServer,this.openUrl=e.openUrl,this.focusWindow=e.focusWindow,this.accessToken=new GitHubAuthStoredValue(e.localStorageService,feature_1.gitHubAccessTokenStorageKey),this.user=new GitHubAuthStoredValue(e.localStorageService,feature_1.gitHubUserStorageKey)}async signIn(){const e=universal_1.isElectronRendererProcess?await this.signInUsingAuthFlowServer():await this.signInUsingPopup();this.accessToken.set(e),this.onAuthStateChange.notify()}signOut(){this.accessToken.delete(),this.user.delete(),this.onAuthStateChange.notify()}isSignedIn(){return void 0!==this.getAccessToken()}getAccessToken(){var e;return(null===(e=this.gitHubUserConfig)||void 0===e?void 0:e.accessToken)?this.gitHubUserConfig.accessToken:this.accessToken.get()}invalidateAccessToken(e){e===this.getAccessToken()&&this.signOut()}async getUser(){var e;return(null===(e=this.gitHubUserConfig)||void 0===e?void 0:e.user)?this.gitHubUserConfig.user:(this.user.get()||await this.refreshUser(),this.user.get())}getCredentials(){const e=this.getAccessToken();return{username:e,password:e?"x-oauth-basic":void 0}}async isAccessTokenValid(){var e;if(null===(e=this.gitHubUserConfig)||void 0===e?void 0:e.accessToken)return!0;try{return await this.refreshUser(),!!this.getAccessToken()}catch(e){return!1}}async refreshUser(){var e,t;if(!this.getAccessToken())return;const s=new rest_1.Octokit({auth:this.getAccessToken()});try{const[{data:i},{data:r}]=await Promise.all([s.users.getAuthenticated({headers:{"if-modified-since":"Thu, 01 Jan 1970 00:00:00 GMT"}}),s.users.listEmailsForAuthenticatedUser()]);this.user.set({id:i.id,login:i.login,email:null!==(e=i.email)&&void 0!==e?e:null===(t=r[0])||void 0===t?void 0:t.email,name:i.name,avatarUrl:i.avatar_url})}catch(e){if(!(e instanceof request_error_1.RequestError&&401===e.status))throw e;this.signOut()}}async signInUsingAuthFlowServer(){const e=this.authFlowServer;await e.start(),this.openUrl(await e.getAuthUrl());const{promise:t,resolve:s}=(0,promise_assist_1.deferred)(),i=e=>{"auth-result"===e.type&&s(e.data)};await e.subscribe(i);const r=await t;if(await e.unsubscribe(i),await e.close(),this.focusWindow(),"accessToken"in r)return r.accessToken;throw new Error(r.error)}async signInUsingPopup(){const e=app_1.default.initializeApp(this.firebaseConfig,"auth");await e.auth().setPersistence(app_1.default.auth.Auth.Persistence.NONE);const t=new app_1.default.auth.GithubAuthProvider;for(const e of github_oauth_scopes_1.gitHubOAuthScopes)t.addScope(e);try{const s=(await e.auth().signInWithPopup(t)).credential;if(!(null==s?void 0:s.accessToken))throw new Error("Access token not found in OAuth response");return s.accessToken}finally{await e.delete()}}}exports.GitHubAuthService=GitHubAuthService;class GitHubAuthStoredValue{constructor(e,t){this.storage=e,this.storageKey=t,this.value=void 0}get(){if(void 0===this.value){const e=this.storage.getStoredValue(feature_1.gitHubAuthFeatureId,this.storageKey);null!==e&&(this.value=JSON.parse(e))}return this.value}set(e){this.value=void 0,this.storage.storeValue(feature_1.gitHubAuthFeatureId,this.storageKey,JSON.stringify(e))}delete(){this.value=void 0,this.storage.clearStoredValue(feature_1.gitHubAuthFeatureId,this.storageKey)}}