"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.UndoRedoService=void 0;const patterns_1=require("@wixc3/patterns"),universal_1=require("@wixc3/editor-commons/universal"),engine_core_1=require("@wixc3/engine-core"),engine_resources_1=require("@wixc3/engine-resources"),constants_1=require("../../universal/constants");class UndoRedoService{constructor(e,s,t,o){this.fileManager=e,this.fileMetaManager=s,this.router=t,this.changesToUndo=[],this.changesToRedo=[],this.knownVersions={},this.isUndoingChanges=!1,this.isRedoingChanges=!1,this.events=new patterns_1.EventEmitter,this._isInitialized=!1,this.onFilesChange=(e,s)=>{const t={};let o="Codux";for(const s of e){const e=s.getCurrentVersion(),n=s.getId();o=this.getModificationOrigin(n);const i=this.getLastKnownVersion(n);(!i||e>i)&&(t[n]=s.getInvertingChangesFromVersion({ofVer:i||0})),this.setLastKnownVersion(n,e)}for(const e of s){const s=e.getId();s.endsWith(".compiled")||(o=this.getModificationOrigin(s),t[s]=void 0)}this.addToUndoStack(t,o),this.customUndoRedoHandler||this.updateResource()},this.undoRedoStatusResource=o.get(constants_1.UNDO_REDO_STATUS_RESOURCE_ID,this)}isInitialized(){return this._isInitialized}init(){this.fileManager.subscribeToAny(this.onFilesChange),this._isInitialized=!0}dispose(){this.fileManager.unsubscribeFromAny(this.onFilesChange),this.undoRedoStatusResource.release(this)}attachCustomHandler(e){if(this.customUndoRedoHandler)throw new Error("Can't attach a custom undo/redo handler, because a different one is already attached");this.customUndoRedoHandler=e}detachCustomHandler(e){if(e&&e!==this.customUndoRedoHandler)throw new Error("Can't remove a custom undo/redo handler, because it wasn't previously attached");this.customUndoRedoHandler=void 0,this.updateResource()}addToUndoStack(e,s){const t={changeset:e,scope:this.scope,source:s};this.isUndoingChanges?this.changesToRedo.push(t):(this.pushNewAction(t),this.isRedoingChanges||(this.changesToRedo=[]))}undo(){if(this.customUndoRedoHandler)return void this.customUndoRedoHandler("undo");const e=(0,universal_1.last)(this.changesToUndo);return e?(this.events.emit("undo",e),this.isUndoingChanges=!0,e.scope&&JSON.stringify(e.scope)!==JSON.stringify(this.scope)?(this.setScope(e.scope),this.router.navigateToPanel(e.scope).catch(engine_core_1.reportError)):(this.applyChangeset(e.changeset),this.isUndoingChanges=!1,this.changesToUndo.pop()),e.source):void 0}redo(){if(this.customUndoRedoHandler)return void this.customUndoRedoHandler("redo");const e=(0,universal_1.last)(this.changesToRedo);return e?(this.events.emit("redo",e),this.isRedoingChanges=!0,e.scope&&JSON.stringify(e.scope)!==JSON.stringify(this.scope)?(this.setScope(e.scope),this.router.navigateToPanel(e.scope).catch(engine_core_1.reportError)):(this.applyChangeset(e.changeset),this.isRedoingChanges=!1,this.changesToRedo.pop()),e.source):void 0}setScope(e){this.scope=e}setLastKnownVersion(e,s){this.knownVersions[e]=s}getLastKnownVersion(e){return this.knownVersions[e]}pushNewAction(e){if(this.changesToUndo.length>0&&void 0!==this.changeBuffer){const s=this.changesToUndo[this.changesToUndo.length-1],t=new Set([...Object.keys(s.changeset),...Object.keys(e.changeset)]);if(JSON.stringify(s.scope)===JSON.stringify(e.scope)){const o={};for(const n of t){const t=engine_resources_1.stringManipulator.squasher([...e.changeset[n]||[],...s.changeset[n]||[]]);o[n]=t}return this.changesToUndo.pop(),this.changesToUndo.push({scope:s.scope,changeset:o,source:s.source}),clearTimeout(this.changeBuffer),void(this.changeBuffer=setTimeout((()=>{this.changeBuffer=void 0}),500))}}this.changesToUndo.push(e),this.changeBuffer=setTimeout((()=>{this.changeBuffer=void 0}),500)}applyChangeset(e){this.fileManager.getBatcher().runAtomic((()=>{for(const s of Object.keys(e)){const t=e[s];void 0===t?this.applyFileChange(s):this.applyStringChanges(s,t)}}))}applyFileChange(e){const s=this.fileManager.get(e);s.isDeleted()?s.restoreDeleted():s.delete()}applyStringChanges(e,s){for(const t of s)this.fileManager.get(e).applyChange(t)}updateResource(){this.undoRedoStatusResource.applyPatch((e=>{e.canUndo=this.changesToUndo.length>0,e.canRedo=this.changesToRedo.length>0}))}getModificationOrigin(e){return this.fileMetaManager.get(e).getLatest().lastModifiedOrigin}subscribeToUndo(e){this.events.on("undo",e)}unsubscribeToUndo(e){this.events.off("undo",e)}subscribeToRedo(e){this.events.on("redo",e)}unsubscribeToRedo(e){this.events.off("redo",e)}resetStacks(){this.changesToUndo=[],this.changesToRedo=[],this.updateResource()}}exports.UndoRedoService=UndoRedoService;