"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ProjectsService=void 0;const universal_1=require("@wixc3/editor-commons/universal"),engine_core_1=require("@wixc3/engine-core"),universal_2=require("@wixc3/git-commands-feature/universal"),feature_1=require("../../feature"),constants_1=require("../constants"),types_1=require("../types"),universal_3=require("../../universal"),utils_1=require("../utils");class ProjectsService{constructor(t,e,r){this.fsService=t,this.storage=e,this.gitRepoInfoService=r,this.projectsEmitter=new universal_1.Signal,this.subscribeToProjects=this.projectsEmitter.subscribe,this.unsubscribeFromProjects=this.projectsEmitter.unsubscribe,this.projects=this.loadProjectsFromStorage(),this.pruneDeletedProjects().then((()=>{const t=this.projects.map((t=>t.path));return this.updateProjectsAccessStatus(t)})).catch(engine_core_1.reportError)}async addProject(t){if(await this.validatePathToExistingProject(t),t=await this.fsService.normalize(t),await this.isProjectAlreadyAdded(t))return;const e={name:await this.fsService.basename(t)||t,path:t};this.projects=[...this.projects,e],this.saveProjectsToStorage(this.projects),this.projectsEmitter.notify(this.projects),this.updateProjectsAccessStatus([t])}removeProject(t){this.projects=this.projects.filter((e=>e.path!==t)),this.saveProjectsToStorage(this.projects),this.projectsEmitter.notify(this.projects)}getProjects(){return this.projects}async validatePathToExistingProject(t){if(!t)throw new Error(universal_3.content.projectPathErrors.pathIsEmpty);if(!await this.fsService.isAbsolute(t))throw new Error(universal_3.content.projectPathErrors.mustBeAbsolute);if(t=await this.fsService.normalize(t),await this.fsService.dirname(t)===t)throw new Error(universal_3.content.projectPathErrors.isDiskRoot);if(!await this.fsService.directoryExists(t))throw new Error(universal_3.content.projectPathErrors.notDirectory)}async updateProjectsAccessStatus(t){const e={[universal_2.RepoAccessStatus.Private]:types_1.ProjectAccessStatus.Private,[universal_2.RepoAccessStatus.Public]:types_1.ProjectAccessStatus.Public,[universal_2.RepoAccessStatus.Unpublished]:types_1.ProjectAccessStatus.Local};for(const r of this.projects)if(t.includes(r.path))try{const t=await this.gitRepoInfoService.getRepoAccessStatus(r.path);r.accessStatus=e[t]}catch(t){r.accessStatus=(0,universal_1.toError)(t).message.includes(universal_2.GitErrorCode.NotAGitRepository)?types_1.ProjectAccessStatus.Local:void 0}this.saveProjectsToStorage(this.projects),this.projectsEmitter.notify(this.projects)}async validatePathToNewProject(t){if(!t)throw new Error(universal_3.content.projectPathErrors.pathIsEmpty);if(!await this.fsService.isAbsolute(t))throw new Error(universal_3.content.projectPathErrors.mustBeAbsolute);if(t=await this.fsService.normalize(t),await this.fsService.dirname(t)===t)throw new Error(universal_3.content.projectPathErrors.isDiskRoot);if(await this.fsService.exists(t))throw new Error(universal_3.content.projectPathErrors.dirAlreadyExist);const e=await this.fsService.basename(t),r=await this.fsService.dirname(t);if(!e)throw new Error(universal_3.content.projectPathErrors.dirNameIsEmpty);if(!(0,utils_1.isProjectNameValid)(e))throw new Error(universal_3.content.projectPathErrors.dirNameInvalid);if(!await this.fsService.directoryExists(r))throw new Error(universal_3.content.projectPathErrors.parentDirNotExist)}async isProjectAlreadyAdded(t){const e=await this.fsService.isCaseSensitive();return this.projects.some((({path:r})=>!r.localeCompare(t,void 0,{sensitivity:e?"case":"accent"})))}loadProjectsFromStorage(){const t=this.storage.getStoredValue(feature_1.PROJECT_PICKER_FEATURE_ID,constants_1.PROJECT_LIST_STORAGE_KEY);return t?JSON.parse(t):[]}saveProjectsToStorage(t){this.storage.storeValue(feature_1.PROJECT_PICKER_FEATURE_ID,constants_1.PROJECT_LIST_STORAGE_KEY,JSON.stringify(t))}async pruneDeletedProjects(){for(const{path:t}of this.projects)await this.fsService.directoryExists(t)||this.removeProject(t)}}exports.ProjectsService=ProjectsService;