"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const tslib_1=require("tslib"),react_1=tslib_1.__importDefault(require("react")),lodash_debounce_1=tslib_1.__importDefault(require("lodash.debounce")),path_1=require("@file-services/path"),feature_1=require("@wixc3/react-renderer-feature/feature"),file_extensions_1=require("../universal/file-extensions"),main_1=require("@wixc3/editor-commons/main"),universal_1=require("@wixc3/editor-commons/universal"),main_2=require("@wixc3/notifications-feature/main"),feature_2=require("@wixc3/project-feature/feature"),main_3=require("../main"),project_ui_feature_1=tslib_1.__importDefault(require("./project-ui.feature")),panel_storage_1=require("../main/services/panel-storage"),delete_confirmation_1=require("../main/components/delete-confirmation/delete-confirmation"),undo_redo_1=require("../main/components/undo-redo/undo-redo"),universal_2=require("../universal"),content_1=require("../universal/content"),file_icon_context_1=require("../main/services/file-icon-context"),file_type_icon_1=require("../universal/file-type-icon"),create_open_file_1=require("../main/utils/create-open-file"),new_fs_item_dialog_1=require("../main/components/new-fs-item-dialog/new-fs-item-dialog"),analytics_1=require("../universal/analytics"),DELETE_FILE_CONFIRMATION_PANEL_TYPE="deleteFile";function getInvalidConfigFileNotificationProps(e="",t){return{id:"invalidConfigToastId",type:"error",text:content_1.notifications.invalidWcsConfigFile.title(e),dismissButton:!0,autoDismiss:!1,button:{text:content_1.notifications.invalidWcsConfigFile.buttonText,onClick:t}}}function registerContextMenuActions({contextMenuSlot:e,projectService:t,panelStore:i,copyPasteManager:n,openFile:o,track:a}){e.register({id:"copy",icon:react_1.default.createElement(main_1.DuplicateSmallIcon,null),label:content_1.fileActions.copy,action:e=>n.setCopyPath(e),section:universal_2.ContextMenuSections.Main,test:(e,t,i)=>t||i}),e.register({id:"cut",icon:react_1.default.createElement(main_1.CutoutIcon,null),label:content_1.fileActions.cut,section:universal_2.ContextMenuSections.Main,action:e=>n.setCopyPath(e,!0),test:()=>!0}),e.register({id:"paste",label:content_1.fileActions.paste,icon:react_1.default.createElement(main_1.PasteIcon,null),section:universal_2.ContextMenuSections.Main,action:e=>n.pasteCopied(e),test:()=>n.isPasteAvailable()}),e.register({id:"new_file",icon:react_1.default.createElement(main_1.AddFileIcon,null),label:content_1.fileActions.newFile,action:e=>{i.openOverlay({id:new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG,panelType:new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG,panelProps:{kind:"File",onCreate:async i=>{const{resolve:n}=(0,universal_1.isWindowsStyleAbsolutePath)(e)?path_1.win32:path_1.posix,r=n(e,i);await t.ensureFileExists(r),o(r,(()=>{a(analytics_1.FILE_OPEN_EVENT,(0,analytics_1.createFileOpenEventProps)(r,"file-explorer-right-click-menu-create-file"))}))},onClose:()=>i.closePanel(new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG)}})},test:(e,t)=>t,section:universal_2.ContextMenuSections.New}),e.register({id:"new_folder",icon:react_1.default.createElement(main_1.NewFolderSmallIcon,null),label:content_1.fileActions.newFolder,action:e=>{i.openOverlay({id:new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG,panelType:new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG,panelProps:{kind:"Folder",onCreate:async i=>{const{resolve:n}=(0,universal_1.isWindowsStyleAbsolutePath)(e)?path_1.win32:path_1.posix,o=n(e,i);await t.addFolder(o)},onClose:()=>i.closePanel(new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG)}})},test:(e,t)=>t,section:universal_2.ContextMenuSections.New}),e.register({id:"copy_relative_path",section:universal_2.ContextMenuSections.Clipboard,icon:react_1.default.createElement(main_1.DuplicateSmallIcon,null),label:content_1.fileActions.copyRelativePath,action:async e=>{const i=await t.getProjectPath();return navigator.clipboard.writeText((0,universal_1.replaceWinSlashes)(path_1.win32.relative(i,e)))},test:()=>!0}),e.register({id:"remove",label:content_1.fileActions.delete,section:universal_2.ContextMenuSections.Delete,icon:react_1.default.createElement(main_1.DeleteSmallIcon,null),action:e=>{i.openOverlay({id:"deleteFileConfirmation",panelType:"deleteFile",panelProps:{onFileDelete:()=>t.removeEntity(e),onClose:()=>i.closePanel("deleteFileConfirmation"),filePath:e}})},test:(e,t,i)=>t||i})}project_ui_feature_1.default.setup(feature_1.mainEnv,(({run:e,onDispose:t,fileTreeConfig:{openedItems:i},openFileSlot:n,fileStylingSlot:o,fileStylingConfig:a,fileChildrenSlot:r,contextMenuSlot:l,decorationIconsSlot:s,openFilesConfig:c,fileIconSlot:_,renderFileIconConfig:u},{analytics:{analyticsService:{track:f}},project:{projectService:d,directoryManagerMain:p,fileManagerMain:m,undoRedoService:g,pluggableProjectConfigMain:y},gui:{sideBarPanelFactory:F,panelStore:P,panelFactory:S,overlayPanelFactory:v,router:E,headerPanelSlot:I,contextSlot:w},notifications:{toastBarStackResource:b},storage:{sessionStorageService:x}})=>{o.setSortingOrder(a),_.setSortingOrder(u);const C={},M=e=>{C[e.extension]={...e}};_.subscribe(M);const h={getFileIconByFilePath:e=>(0,file_type_icon_1.getFileIcon)({filePath:e,extensions:C}),getFileIconByTreeItem:e=>(0,file_type_icon_1.getFileIconByTreeItem)({dataItem:e,extensions:C})};w.register({context:file_icon_context_1.FileIconContext,value:h.getFileIconByFilePath});for(const[e,t]of Object.entries(file_extensions_1.fileExtensions))_.register({Icon:t,extension:e});const T=new main_3.FileTreeStore(p,r,d.getProjectPath,i),N=new main_3.CopyPasteManager(d),O=new main_3.SlotsProcessor(l,n,o,s,E,h),A=new main_3.OpenFilesService(c.targetAreaGroup,P,h),q=(0,create_open_file_1.createOpenFile)(n,E);I.register({id:universal_2.UNDO_REDO_BUTTONS_ID,Header:()=>react_1.default.createElement(undo_redo_1.UndoRedoContainer,{undoRedoService:g}),alignment:"right"}),registerContextMenuActions({contextMenuSlot:l,projectService:d,copyPasteManager:N,openFile:q,panelStore:P,track:f});const D=async(e,t)=>{const i=await d.changeBaseName(e,t);for(const{test:t,panelFactoryType:o}of n.values())if(t(e)){A.renameFileTab({panelFactoryType:o,props:{filePath:i},oldFileName:e});break}};F.register({id:universal_2.FILE_EXPLORER_TYPE,title:content_1.title,factory:()=>react_1.default.createElement(main_3.FileExplorer,{getProjectName:d.getProjectName,onFileRename:D,onNodeMove:d.moveEntity,copyPasteManager:N,fileTreeStore:T,onSelect:q,toggledItemsIds:i,slotsProcessor:O}),icon:react_1.default.createElement(main_1.ArticleIcon,null)}),s.register((0,main_3.initModifiedIconPlugin)(m)),o.register((0,main_3.initModifiedStylePlugin)(m)),v.register({id:"deleteFile",factory:e=>react_1.default.createElement(delete_confirmation_1.DeleteConfirmation,{...e})}),v.register({id:new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG,factory:e=>react_1.default.createElement(new_fs_item_dialog_1.NewFsItemDialog,{...e})}),n.stream(((e,{panelFactoryType:t,factory:i,area:n,tabTitle:o=path_1.win32.basename})=>{i&&S.register({id:t,factory:i,route:e=>{const{filePath:t,type:i}=e;if(!t||!i)throw new Error("Required query params missing");const a=h.getFileIconByFilePath(t);return{icon:a&&react_1.default.createElement(a,null),title:o(t),id:A.getPanelId(t,i),props:{filePath:t},area:n}}})}));return e((async()=>{await T.init();for(const{filePath:e,panelType:t}of c.openFiles)A.openFile({props:{filePath:e},panelFactoryType:t});const e=new panel_storage_1.PanelStorage(x,P,S,await d.getProjectPath());e.restore();const i=()=>e.store();P.subscribe(i);const n=await y.getReady(feature_2.PROJECT_CONFIG_NAME),o=(0,lodash_debounce_1.default)((()=>{(async e=>{const{valid:t,message:i}=e.getStatus(),n=await d.getProjectPath(),o=await d.join(n,feature_2.PROJECT_CONFIG_NAME);if(!await d.fileExists(o))return;if(t)return void(0,main_2.closeToastNotification)({toastBarStackResource:b,id:i});(0,main_2.openToastNotification)({toastBarStackResource:b,props:getInvalidConfigFileNotificationProps(i,(()=>q(o,(()=>f(analytics_1.FILE_OPEN_EVENT,(0,analytics_1.createFileOpenEventProps)(o,"toast-bar-config-notification"))))))})})(n)}),300);n.subscribe(o),o(),t((()=>{_.unSubscribe(M),P.unsubscribe(i),n.unsubscribe(o)}))})),{fileTreeStore:T,copyPasteManager:N,openFilesService:A,slotsProcessor:O,fileIconService:h}}));