"use strict";var __rest=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var i=0;for(n=Object.getOwnPropertySymbols(e);i<n.length;i++)t.indexOf(n[i])<0&&Object.prototype.propertyIsEnumerable.call(e,n[i])&&(r[n[i]]=e[n[i]])}return r};Object.defineProperty(exports,"__esModule",{value:!0}),exports.toDescriptionDoc=exports.referenceToDoc=exports.convert=void 0;const schema_predicates_1=require("./schema-predicates"),object_utils_1=require("./object-utils"),utils_1=require("./utils"),schemaConverters=[[schema_predicates_1.isSimpleType,simpleTypeToDoc],[schema_predicates_1.isLiteral,literalTypeToDoc],[schema_predicates_1.isArray,arrayTypeToDoc],[schema_predicates_1.isReadonlyArray,arrayTypeToDoc],[schema_predicates_1.isInterface,interfaceSchemaToDoc],[schema_predicates_1.isObject,objectSchemaToDoc],[schema_predicates_1.isFunction,functionToDoc],[schema_predicates_1.isClassInstance,objectSchemaToDoc],[schema_predicates_1.isConditional,conditionalToDoc],[schema_predicates_1.isReference,referenceToDoc],[schema_predicates_1.isNonPrimitiveUnion,unionToDoc],[schema_predicates_1.isIntersection,intersectionToDoc],[schema_predicates_1.isAny,anyToDoc]],convert=(e,t=!1)=>{var r,n,i,o,a,c,s,u,p,d,l,m;if("property"in e){if((0,schema_predicates_1.isClass)(e.property))return classToDoc({name:e.name,properties:null===(r=e.definition)||void 0===r?void 0:r.properties,constructor:null===(n=e.property)||void 0===n?void 0:n.constructor,staticProperties:null===(i=e.property)||void 0===i?void 0:i.properties,genericParams:null===(o=e.definition)||void 0===o?void 0:o.genericParams,required:null===(a=e.definition)||void 0===a?void 0:a.required,jsDoc:null===(c=e.definition)||void 0===c?void 0:c.jsDoc,extendsType:Array.isArray(null===(s=e.definition)||void 0===s?void 0:s.extends)||null===(u=e.definition)||void 0===u?void 0:u.extends},t);if((0,schema_predicates_1.isEnum)(e.property))return enumSchemaToDoc({name:e.name,properties:null===(p=e.property)||void 0===p?void 0:p.properties,jsDoc:null===(d=e.property)||void 0===d?void 0:d.jsDoc,oneOf:null===(l=e.definition)||void 0===l?void 0:l.oneOf,definedAt:null===(m=e.definition)||void 0===m?void 0:m.definedAt});if((0,schema_predicates_1.isSimpleType)(e.property)||(0,schema_predicates_1.isUnion)(e.property)||(0,schema_predicates_1.isIntersection)(e.property)||(0,schema_predicates_1.isArray)(e.property)||(0,schema_predicates_1.isObject)(e.property)||(0,schema_predicates_1.isReference)(e.property))return convertDeclaration(e)}if("type"in e&&"common/nonprimitive"===e.type)return objectSchemaToDoc(e,t);for(const[r,n]of schemaConverters){if(r(e))return n(e,t);if("property"in e&&r(e.property))return n(Object.assign({name:e.name},e.property)||{},t,!1);if("definition"in e&&r(e.definition))return n(Object.assign({name:e.name},e.definition)||{},t,!0)}return(0,schema_predicates_1.isEmptyOrError)(e)?{kind:"error",id:(0,utils_1.generateId)(),error:"$error"in e?e.$error:void 0}:{id:(0,utils_1.generateId)(),kind:"unsupported"}};function convertDeclaration(e){var t;return{id:(0,utils_1.generateId)(),kind:"declaration",name:null!==(t=e.name)&&void 0!==t?t:"",property:propertyToDoc((null==e?void 0:e.property)||{},e,"")}}function anyToDoc(){return{id:(0,utils_1.generateId)(),kind:"any"}}function schemaEnumMemberToLiteral(e,t){switch(e.type){case"number":return{id:(0,utils_1.generateId)(),entityName:"type",kind:"numericLiteral",value:t};case"string":return{id:(0,utils_1.generateId)(),entityName:"type",kind:"stringLiteral",value:t};case"boolean":return{id:(0,utils_1.generateId)(),entityName:"type",kind:"booleanLiteral",value:t};default:return{id:(0,utils_1.generateId)(),kind:"unsupported"}}}function literalTypeToDoc(e){var t;return{id:(0,utils_1.generateId)(),kind:"union",name:null!==(t=e.name)&&void 0!==t?t:"",entityName:"type",description:toDescriptionDoc(e.jsDoc),types:e.enum?e.enum.map((t=>schemaEnumMemberToLiteral(e,t))):[]}}function getArrayDisplayType(e){switch(e.kind){case"any":case"simpleType":case"reference":default:return"squareBrackets";case"numericLiteral":case"stringLiteral":case"booleanLiteral":case"union":return"angularBrackets";case"array":case"readonlyArray":return"squareBrackets"===e.displayType||"angularBrackets"===e.displayType?"angularBrackets":"squareBrackets"}}function isComplexType(e){switch(e.kind){case"any":case"simpleType":case"numericLiteral":case"stringLiteral":case"booleanLiteral":case"intersection":case"union":case"reference":return!1;case"array":case"readonlyArray":return"squareBrackets"!==e.displayType;default:return!0}}function convertEnumProps(e){var t,r;return e.oneOf?(0,object_utils_1.reduceObject)((([e,t],r,n)=>{var i;return[Object.assign(Object.assign({},e),{[r]:Object.assign(Object.assign({},n),{defaultValue:null!==(i=n.defaultValue)&&void 0!==i?i:t})}),"number"==typeof n.defaultValue?n.defaultValue+1:t+1]}),[{},0],null!==(r=e.properties)&&void 0!==r?r:{})[0]:(0,object_utils_1.mapValues)((t=>{var r;return Object.assign(Object.assign({},t),{defaultValue:e.definedAt?void 0:null!==(r=t.defaultValue)&&void 0!==r?r:0})}),null!==(t=e.properties)&&void 0!==t?t:{})}function arrayTypeToDoc(e){var t,r;if(Array.isArray(e.items))return{id:(0,utils_1.generateId)(),kind:"tuple",name:null!==(t=e.name)&&void 0!==t?t:"",entityName:"tuple",itemTypes:e.items.map(tupleItemToDoc),restType:(null==e?void 0:e.additionalItems)?tupleItemToDoc(null==e?void 0:e.additionalItems):null,description:toDescriptionDoc(e.jsDoc)};const n=(0,exports.convert)(e.items||{});return{id:(0,utils_1.generateId)(),kind:"array"===e.type?"array":"readonlyArray",entityName:"type",name:null!==(r=e.name)&&void 0!==r?r:"",itemType:n,description:toDescriptionDoc(e.jsDoc),displayType:getArrayDisplayType(n)}}function tupleItemToDoc(e){return{id:(0,utils_1.generateId)(),kind:"tupleItem",name:e.label,type:(0,exports.convert)(e),variadic:!!e.variadic}}function getRequired(e,t){return(t.required||[]).includes(e)}function getRequiredArgument(e,t){return(t.requiredArguments||[]).includes(e)}function extractOptionalType(e){const{oneOf:t}=e,r=__rest(e,["oneOf"]),n=(null==t?void 0:t.filter((e=>"common/undefined"!==e.type)))||[];return 1===n.length?Object.assign(Object.assign({},r),n[0]):Object.assign(Object.assign({},r),{oneOf:n})}function propertyToDoc(e,t,r){const n=getRequired(r,t);return{id:(0,utils_1.generateId)(),kind:"typeItem",name:r,type:(0,exports.convert)(e),required:n,description:toDescriptionDoc(e.jsDoc),defaultValue:JSON.stringify(e.defaultValue)||null}}function typeParameterToDoc(e){var t;return{id:(0,utils_1.generateId)(),kind:"typeParameter",name:null!==(t=e.name)&&void 0!==t?t:"",type:(0,exports.convert)(e.constraint||{type:"any"}),description:toDescriptionDoc(e.jsDoc),defaultValue:e.default?(0,exports.convert)(e.default):null}}function genericArgumentToDoc(e){var t;const r=(0,exports.convert)(e||{type:"any"});return{id:(0,utils_1.generateId)(),kind:"genericArgument",name:null!==(t=e.name)&&void 0!==t?t:"",type:r,isComplex:isComplexType(r)}}function argumentToDoc(e,t,r,n){const i=getRequiredArgument(r,t);return{id:(0,utils_1.generateId)(),kind:"typeItem",name:r,type:(0,exports.convert)(i?e:extractOptionalType(e)),required:i,description:toDescriptionDoc(e.jsDoc||n),defaultValue:JSON.stringify(e.defaultValue)||null}}function convertSignatureReturnValue(e){var t,r,n,i,o;const a={description:null!==(i=null===(n=null===(r=null===(t=e.jsDoc)||void 0===t?void 0:t.tags)||void 0===r?void 0:r.find((e=>"returns"===e.tagName)))||void 0===n?void 0:n.text)&&void 0!==i?i:""};return{id:(0,utils_1.generateId)(),kind:"typeItem",name:"",type:(0,exports.convert)(null!==(o=e.returns)&&void 0!==o?o:{}),required:!1,description:toDescriptionDoc(a),defaultValue:null}}function propertiesToDoc(e,t){return(0,object_utils_1.mapObject)(((e,r)=>propertyToDoc(r,t,e)),e)}function genericArgumentsToDoc(e){return e.map((e=>genericArgumentToDoc(e)))}function typeParametersToDoc(e){return e.map((e=>typeParameterToDoc(e)))}function interfaceSchemaToDoc(e,t){var r;if(!t)return expandableTypeToDoc(e);const{properties:n}=e,i=Object.assign({},n);return{id:(0,utils_1.generateId)(),kind:"interface",name:null!==(r=e.name)&&void 0!==r?r:"",entityName:"interface",extendsTypes:[],description:toDescriptionDoc(e.jsDoc),properties:propertiesToDoc(i||{},e),typeParameters:typeParametersToDoc(e.genericParams||[])}}function formatJSONSchemaType(e){return void 0===e?"unsupported type":Array.isArray(e)?e.join(" "):e.replace("common/","")}function simpleTypeToDoc(e){var t;return{id:(0,utils_1.generateId)(),kind:"simpleType",name:null!==(t=e.name)&&void 0!==t?t:"",entityName:"type",type:formatJSONSchemaType(e.type),description:toDescriptionDoc(e.jsDoc)}}function objectSchemaToDoc(e,t){var r,n;return t||!e.properties||(0,object_utils_1.isEmpty)(e.properties)?{id:(0,utils_1.generateId)(),kind:"object",name:null!==(n=null!==(r=e.name)&&void 0!==r?r:(0,utils_1.isTypescriptRef)(e.definedAt)?"":e.definedAt)&&void 0!==n?n:"",entityName:"object",description:toDescriptionDoc(e.jsDoc),properties:propertiesToDoc(e.properties||{},e),typeParameters:typeParametersToDoc(e.genericParams||[])}:expandableTypeToDoc(e)}function referenceToDoc(e){var t,r;const n=null!==(t=e.$ref)&&void 0!==t?t:"",{genericArguments:i}=e;return{id:(0,utils_1.generateId)(),kind:"reference",name:null!==(r=e.name)&&void 0!==r?r:"",entityName:"type",ref:n,definedAt:e.propertyDefinedAt,schema:e,typeArguments:genericArgumentsToDoc(i||[]),description:toDescriptionDoc(e.jsDoc)}}function functionSignatureToDoc(e){var t;const r=e.arguments?e.arguments.map((t=>{var r;return argumentToDoc(t,e,null!==(r=t.name)&&void 0!==r?r:"",getArgumentJsDoc(e.jsDoc,t.name))})):[];return e.restArgument&&r.push(argumentToDoc(e.restArgument,e,`...${e.restArgument.name}`,getArgumentJsDoc(e.jsDoc,e.restArgument.name))),{id:(0,utils_1.generateId)(),kind:"functionSignature",name:null!==(t=e.name)&&void 0!==t?t:"",arguments:r,returnValue:convertSignatureReturnValue(null!=e?e:{}),description:toDescriptionDoc(e.jsDoc),typeParameters:typeParametersToDoc(e.genericParams||[])}}function constructorSignatureToDoc(e,t){var r;return{id:(0,utils_1.generateId)(),kind:"constructorSignature",name:"",arguments:e.arguments?e.arguments.map((t=>{var r;return argumentToDoc(t,e,null!==(r=t.name)&&void 0!==r?r:"",getArgumentJsDoc(e.jsDoc,t.name))})):[],description:toDescriptionDoc(e.jsDoc),classTypeParameters:typeParametersToDoc(t.genericParams||[]),className:null!==(r=t.name)&&void 0!==r?r:""}}function functionToDoc(e,t,r=!1){var n;return t?{id:(0,utils_1.generateId)(),kind:"function",name:null!==(n=e.name)&&void 0!==n?n:"",entityName:"function",signatures:e.signatures?e.signatures.map((e=>functionSignatureToDoc(e))):[],description:toDescriptionDoc(e.jsDoc),isDefinition:r}:expandableTypeToDoc(e)}function constructorToDoc(e,t){return{id:(0,utils_1.generateId)(),kind:"constructor",signatures:e.signatures?e.signatures.map((e=>constructorSignatureToDoc(e,t))):[],description:toDescriptionDoc(e.jsDoc)}}function classToDoc(e,t){var r,n,i;if(!t)return expandableTypeToDoc(e);const o=(0,object_utils_1.filterObject)(((e,{accessModifier:t})=>"private"===t),(null==e?void 0:e.properties)||{}),a=(0,object_utils_1.filterObject)(((e,{accessModifier:t})=>"public"===t),(null==e?void 0:e.properties)||{});return{id:(0,utils_1.generateId)(),kind:"class",name:null!==(r=e.name)&&void 0!==r?r:"",entityName:"class",description:toDescriptionDoc(e.jsDoc),extendsType:null!==(i=null===(n=e.extendsType)||void 0===n?void 0:n.$ref)&&void 0!==i?i:null,implementsTypes:[],constructor:Object.prototype.hasOwnProperty.call(e,"constructor")&&void 0!==e.constructor?constructorToDoc(e.constructor,e):null,privateMembers:propertiesToDoc(o,e),publicMembers:propertiesToDoc(a,e),staticMembers:propertiesToDoc(e.staticProperties||{},e),typeParameters:typeParametersToDoc(e.genericParams||[])}}function conditionalToDoc(e,t){var r,n,i;return t?{id:(0,utils_1.generateId)(),kind:"conditional",name:null!==(r=e.name)&&void 0!==r?r:"",entityName:"conditional type",description:toDescriptionDoc(e.jsDoc),checkTypeRef:null!==(i=null===(n=e.checkType)||void 0===n?void 0:n.$ref)&&void 0!==i?i:"",extendsType:(0,exports.convert)(e.extendsType||{}),thenType:(0,exports.convert)(e.then||{}),elseType:(0,exports.convert)(e.else||{})}:expandableTypeToDoc(e)}function expandableTypeToDoc(e){var t;return{id:(0,utils_1.generateId)(),kind:"expandableType",name:e.definedAt&&!(0,utils_1.isTypescriptRef)(e.definedAt)?e.definedAt:null!==(t=e.type)&&void 0!==t?t:"",schema:e}}function enumSchemaToDoc(e){var t;return{id:(0,utils_1.generateId)(),kind:"enum",name:null!==(t=e.name)&&void 0!==t?t:"",entityName:"enum",properties:propertiesToDoc(convertEnumProps(e),e),description:toDescriptionDoc(e.jsDoc)}}function flattenUnionTypes(e){return e.flatMap((e=>(0,schema_predicates_1.isLiteral)(e)?Array.isArray(e.enum)?e.enum.map((t=>schemaEnumMemberToLiteral(e,t))):[]:(0,exports.convert)(e)))}function unionToDoc(e){var t;const r=flattenUnionTypes(e.oneOf||[]);return{id:(0,utils_1.generateId)(),kind:"union",name:null!==(t=e.name)&&void 0!==t?t:"",entityName:"union",types:r,description:toDescriptionDoc(e.jsDoc)}}function intersectionToDoc(e){var t;const r=(e.allOf||[]).map((e=>(0,exports.convert)(e)));return{id:(0,utils_1.generateId)(),kind:"intersection",name:null!==(t=e.name)&&void 0!==t?t:"",entityName:"intersection",types:r,description:toDescriptionDoc(e.jsDoc)}}function getArgumentJsDoc(e,t){if(e&&t){const r=e&&e.tags&&e.tags.find((e=>e.param&&e.param===t));if(r)return{description:r.text}}}function toDescriptionDoc(e){let t="";return e&&e.tags&&([t]=e.tags.filter((e=>"see"===e.tagName||"link"===e.tagName)).map((e=>e.text))),{id:(0,utils_1.generateId)(),kind:"description",content:e&&e.description?e.description:"",mdPath:t}}exports.convert=convert,exports.referenceToDoc=referenceToDoc,exports.toDescriptionDoc=toDescriptionDoc;