"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.borderImageSlicePredicate=exports.textDecorationLinePredicate=exports.gridAutoFlowPredicate=exports.gridTemplateAreasStringPredicate=exports.autoTrackListPredicate=exports.getTrackListRowsText=exports.getTrackListAreasText=exports.trackListWithStringsPredicate=exports.parseTrackListWithStrings=exports.explicitTrackListPredicate=exports.trackListPredicate=exports.trackSizePredicate=exports.lineNamesPredicate=exports.gridLinePredicate=exports.fontFamilyStringPredicate=exports.fontStylePredicate=exports.autoKeywordPredicate=exports.anglePredicate=exports.calcPredicate=exports.lengthPercentagePredicate=exports.percentagePredicate=exports.lengthPredicate=exports.numberPredicate=void 0;const tokenizers_1=require("../tokenizers"),data_types_consts_1=require("./data-types-consts"),data_types_utils_1=require("./data-types-utils");exports.numberPredicate=(0,data_types_utils_1.dimensionPredicate)(),exports.lengthPredicate=(0,data_types_utils_1.dimensionPredicate)({units:data_types_consts_1.LENGTH_UNITS_MAP}),exports.percentagePredicate=(0,data_types_utils_1.dimensionPredicate)({units:data_types_consts_1.PERCENTAGE_UNIT}),exports.lengthPercentagePredicate=(0,data_types_utils_1.dimensionPredicate)({units:data_types_consts_1.LENGTH_PERCENTAGE_UNITS}),exports.calcPredicate=(0,data_types_utils_1.functionPredicate)(data_types_consts_1.CALC_FUNCTION),exports.anglePredicate=(0,data_types_utils_1.dimensionPredicate)({units:data_types_consts_1.ANGLE_UNITS});const flexPredicate=(0,data_types_utils_1.dimensionPredicate)({units:data_types_consts_1.FLEX_UNIT,min:data_types_consts_1.FLEX_NUMBER_RANGE_MIN});exports.autoKeywordPredicate=(0,data_types_utils_1.unorderedListPredicate)(data_types_consts_1.AUTO_KEYWORD);const fontStylePredicate=(e,t,a)=>{if(void 0===t||!a)return!1;let r=0;if((0,data_types_utils_1.unorderedListPredicate)(data_types_consts_1.FONT_STYLE_OBLIQUE_KEYWORD)(e)){r++;const e=a[t+1];e&&(0,exports.anglePredicate)(e.value)&&r++}return r};exports.fontStylePredicate=fontStylePredicate,exports.fontFamilyStringPredicate=(0,data_types_utils_1.typePredicate)(["text","string",","]);const gridLinePredicate=(e,t,a)=>{const r=null!=t?t:0,s=null!=a?a:[{value:e}],i=(0,data_types_utils_1.dimensionPredicate)({nonZero:!0,integer:!0}),c=(0,data_types_utils_1.customIdentPredicate)(data_types_consts_1.GRID_LINE_SPAN_KEYWORD),n=(0,data_types_utils_1.unorderedListPredicate)(data_types_consts_1.GRID_LINE_SPAN_KEYWORD);let _,d=!1,o=!1,l=!1,u=r;for(;_=s[u++];)if(c(_.value)){if(o)break;o=!0}else if(i(_.value)){if(l)break;l=!0}else{if(!n(_.value))break;if(d)break;d=!0}return!(d&&!o&&!l)&&+d+ +o+ +l};exports.gridLinePredicate=gridLinePredicate;const trackBreadthPredicate=(0,data_types_utils_1.predicateUnion)([exports.lengthPercentagePredicate,flexPredicate,(0,data_types_utils_1.unorderedListPredicate)(data_types_consts_1.BREADTH_KEYWORDS)]),INVALID_LINE_NAMES_MATCH={names:[],match:!1},parseLineNames=(e,t,a)=>{const r=null!=t?t:0,s=null!=a?a:[{value:e}],i=(0,data_types_utils_1.customIdentPredicate)(data_types_consts_1.LINE_NAMES_EXCLUDE_KEYWORDS),c=[];let n=0,_=!1;for(let e=r;e<s.length;e++){const t=s[e].value;let a=t.text;const d=e===r,o=a.startsWith("[");if(_=a.endsWith("]"),"text"!==t.type||d&&!o||!d&&o)return{...INVALID_LINE_NAMES_MATCH};if(a=a.slice(o?1:0,a.length-(_?1:0)),""!==a&&(a.includes("[")||a.includes("]")||!i((0,tokenizers_1.valueTextNode)(a))))return{...INVALID_LINE_NAMES_MATCH};if(""!==a&&c.push(a),n++,_)break}return _?{names:c,match:n}:{...INVALID_LINE_NAMES_MATCH}},lineNamesPredicate=(e,t,a)=>parseLineNames(e,t,a).match;exports.lineNamesPredicate=lineNamesPredicate,exports.trackSizePredicate=(0,data_types_utils_1.predicateUnion)([trackBreadthPredicate,(0,data_types_utils_1.functionPredicate)(data_types_consts_1.TRACK_SIZE_FUNCTIONS)]);const repeatPredicate=(0,data_types_utils_1.functionPredicate)(data_types_consts_1.REPEAT_FUNCTION),autoRepeatPredicate=e=>{if(repeatPredicate(e)){const t=(0,data_types_utils_1.unorderedListPredicate)(data_types_consts_1.AUTO_REPEAT_FIRST_ARGUMENT_KEYWORDS),a=e.args[0];if(a)return t(a)}return!1},fixedSizePredicate=(0,data_types_utils_1.predicateUnion)([exports.lengthPercentagePredicate,(0,data_types_utils_1.functionPredicate)(data_types_consts_1.MINMAX_FUNCTION)]),singleTrackPredicate=(e,t=!1)=>(a,r,s)=>{const i=null!=s?s:[{value:a}];let c,n=null!=r?r:0,_=!1,d=t,o=0;for(;c=i[n];){const t=parseLineNames(c.value,n,i).match;if(t){if(_)break;n+=Number(t),o+=Number(t),_=!0}else{if(!e.some((e=>e(c.value))))break;d=!0,_=!1,n++,o++}}return!!d&&o};exports.trackListPredicate=singleTrackPredicate([exports.trackSizePredicate,repeatPredicate]),exports.explicitTrackListPredicate=singleTrackPredicate([exports.trackSizePredicate]);const EMPTY_TRACK={string:"",trackSize:data_types_consts_1.INITIAL_TRACK_SIZE},INVALID_TRACK_MATCH={tracks:[],match:!1},parseTrackListWithStrings=(e,t,a)=>{const r=null!=t?t:0,s=null!=a?a:[{value:e}],i=[{...EMPTY_TRACK}];let c,n=r,_=!1,d=0;for(;c=s[n];){if("string"===c.value.type)i[i.length-1].string=c.value.text,_=!0;else{const e=""===i[i.length-1].string,t=parseLineNames(c.value,n,s);if(t.match){if(e){if(i[i.length-1].lineNamesBefore)return{...INVALID_TRACK_MATCH};i[i.length-1].lineNamesBefore=t.names,_=!1}else i[i.length-1].lineNamesAfter=t.names,i.push({...EMPTY_TRACK});n+=Number(t.match)-1,d+=Number(t.match)-1}else{if(!(0,exports.trackSizePredicate)(c.value,n,s))break;if(e)return{...INVALID_TRACK_MATCH};i[i.length-1].trackSize=c.value.text}}n++,d++}return _&&""===i[i.length-1].string&&i.pop(),_?{tracks:i,match:d}:{...INVALID_TRACK_MATCH}};exports.parseTrackListWithStrings=parseTrackListWithStrings;const trackListWithStringsPredicate=(e,t,a)=>(0,exports.parseTrackListWithStrings)(e,t,a).match;exports.trackListWithStringsPredicate=trackListWithStringsPredicate;const getTrackListAreasText=({tracks:e})=>e.map((({string:e})=>e)).join(" ");exports.getTrackListAreasText=getTrackListAreasText;const getTrackListRowsText=({tracks:e})=>e.map((({trackSize:t,lineNamesBefore:a,lineNamesAfter:r},s)=>{const i=0===s&&a?`[${a.join(" ")}] `:"";let c=null!=r?r:[];const n=e[s+1];n&&n.lineNamesBefore&&(c=c.concat(n.lineNamesBefore));return`${i}${t}${c.length>0?` [${c.join(" ")}]`:""}`})).join(" ");exports.getTrackListRowsText=getTrackListRowsText;const autoTrackListPredicate=(e,t,a)=>{const r=null!=t?t:0,s=null!=a?a:[{value:e}];let i,c=r,n=-1;for(;i=s[c];){if(autoRepeatPredicate(i.value)){n=c;break}c++}if(-1===n)return!1;const _=singleTrackPredicate([fixedSizePredicate,repeatPredicate],!0);let d=1;if(n>r){const e=_(s[r].value,0,s.slice(r,n));if(!e||Number(e)!==n-r)return!1;d+=n-r}return s[n+1]&&(d+=Number(_(s[n+1].value,0,s.slice(n+1)))),d};exports.autoTrackListPredicate=autoTrackListPredicate,exports.gridTemplateAreasStringPredicate=(0,data_types_utils_1.typePredicate)(["string"]);const gridAutoFlowPredicate=(e,t,a)=>{const r=null!=t?t:0,s=null!=a?a:[{value:e}],i=(0,data_types_utils_1.unorderedListPredicate)(data_types_consts_1.GRID_AUTO_FLOW_KEYWORD),c=(0,data_types_utils_1.unorderedListPredicate)(data_types_consts_1.GRID_AUTO_FLOW_DENSE_KEYWORD);let n,_=!1,d=!1,o=r;for(;n=s[o++];)if(i(n.value)){if(_)break;_=!0}else{if(!c(n.value))break;if(d)break;d=!0}return!!_&&+_+ +d};exports.gridAutoFlowPredicate=gridAutoFlowPredicate;const textDecorationLinePredicate=(e,t,a)=>{const r=null!=t?t:0,s=null!=a?a:[{value:e}],i=new Map(data_types_consts_1.TEXT_DECORATION_LINE_KEYWORDS);let c,n=(0,data_types_utils_1.unorderedListPredicate)(i),_=r,d=0;for(;i.size>0&&(c=s[_++])&&n(c.value,_-1,s);)d++,i.delete(c.value.text),n=(0,data_types_utils_1.unorderedListPredicate)(i);return d};exports.textDecorationLinePredicate=textDecorationLinePredicate;const borderImageSlicePredicate=(e,t,a)=>{const r=null!=t?t:0,s=null!=a?a:[{value:e}],i=[exports.numberPredicate,exports.percentagePredicate],c=(0,data_types_utils_1.unorderedListPredicate)(data_types_consts_1.BORDER_IMAGE_SLICE_FILL_KEYWORD);let n,_,d=r,o=0,l=!1;for(;n=s[d++];){_=void 0;const e=c(n.value,d-1,s);if(e){if(l)break;_=e,l=!0}else for(const e of i){const t=e(n.value,d-1,s);if(t){_=t;break}}if(!_||++o==(l?5:4))break}return 4===o&&_&&(n=s[d])?c(n.value,d-1,s)?5:4:o>=1&&((!l||o>1)&&o)};exports.borderImageSlicePredicate=borderImageSlicePredicate;