"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.stringifyGradient=exports.normalizeGradientOrientation=exports.normalizeGradientColorStop=exports.isStripesGradient=exports.parseSolidGradient=exports.solidGradient=exports.parseGradient=exports.gradientFromAST=exports.verifiedExpandGradient=exports.divideColorStops=exports.expandGradient=void 0;var tslib_1=require("tslib"),chroma_js_1=tslib_1.__importDefault(require("chroma-js")),gradient_parser_1=require("gradient-parser"),stylable_shorthands_1=require("./stylable-shorthands"),property_parser_1=require("./utils/css-utils/property-parser"),GRADIENT_MATCHER=/\S+-gradient/;function expandGradient(r,e,t){var o,n,a=r.match(GRADIENT_MATCHER);if(a&&void 0!==a.index){var i=r.slice(a.index+a[0].length+1),s="".concat(a[0],"(").concat(i.slice(0,(0,stylable_shorthands_1.findEndOfClosure)(i)),")"),l=r.replace(s,"").trim(),p={};if(l)try{p=(0,property_parser_1.expandShorthandCssProp)(t,l)}catch(r){}try{return tslib_1.__assign(tslib_1.__assign({},p),((o={})[e]=(0,gradient_parser_1.parse)(s)[0],o))}catch(r){}}try{return(0,property_parser_1.expandShorthandCssProp)(t,r)}catch(r){}return(n={})[t]=r,n}function divideColorStops(r){if(!r||r.length<2)return[];for(var e=[],t=0;t<r.length;t++){var o=r[t],n="";o.length?n="".concat(o.length.value).concat(o.length.type):0===t?n="0%":t===r.length-1&&(n="100%");var a=normalizeGradientColorStop(o),i=(0,chroma_js_1.default)(a),s=i.alpha()<1?a:i.hex("rgb");e.push({color:s,length:n})}var l=-1,p=-1;for(t=0;t<e.length;t++){if(e[t].length)if(-1===l)l=t;else{if((p=t)>l+1)for(var c=parseFloat(e[l].length),d=p-l,u=(parseFloat(e[p].length)-c)/d,g=1;g<d;g++)e[l+g].length="".concat((c+u*g).toFixed(2),"%");l=p=-1}}return e}function verifiedExpandGradient(r){if(!r)return null;var e=expandGradient(r,"background-image","background");if(void 0!==e.background||e["background-image"]===r)return null;var t=e["background-image"];return!t||!t.colorStops||t.colorStops.length<2?null:e}function gradientFromAST(r){var e={type:r.type,colorStops:divideColorStops(r.colorStops),orientation:normalizeGradientOrientation(r.type,r.orientation),steps:-1};return r.position&&r.size?tslib_1.__assign(tslib_1.__assign({},e),{position:r.position,size:r.size}):e}function parseGradient(r){var e=verifiedExpandGradient(r);if(e){var t=e["background-image"],o=e["background-position"],n=e["background-size"];return gradientFromAST(o&&n?tslib_1.__assign(tslib_1.__assign({},t),{position:o,size:n}):t)}return null}function solidGradient(r){return"linear-gradient(".concat(r,", ").concat(r,")")}function parseSolidGradient(r){if(!r||!r.startsWith("linear-gradient"))return null;var e=verifiedExpandGradient(r);if(!e)return null;var t=e["background-image"],o=t.colorStops.map((function(r){return normalizeGradientColorStop(r)}));return"linear-gradient"===t.type&&o.every((function(r){return r===o[0]}))?o[0]:null}function isStripesGradient(r){return"repeating-linear-gradient"===r.type&&4===r.colorStops.length&&"0%"===r.colorStops[0].length&&r.colorStops[1].length.endsWith("px")&&r.colorStops[1].length.endsWith("px")&&r.colorStops[2].length.endsWith("px")&&r.colorStops[1].length===r.colorStops[2].length&&parseFloat(r.colorStops[2].length)<=parseFloat(r.colorStops[3].length)&&r.colorStops[0].color===r.colorStops[1].color&&r.colorStops[2].color===r.colorStops[3].color}function normalizeGradientColorStop(r){switch(r.type){case"hex":return"#".concat(r.value);case"rgb":case"rgba":return"".concat(r.type,"(").concat(r.value.join(", "),")")}return"transparent"===r.value?"rgba(255, 255, 255, 0)":r.value}function normalizeGradientOrientation(r,e){if(!e)return~r.indexOf("linear")?"180deg":"ellipse at 50% 50%";if(Array.isArray(e)&&void 0!==e.length){var t=e[0].value,o=e[0].at.value,n="";t&&(n="".concat(t," ")),n+="at ";var a=o.x,i=o.y;if("position-keyword"===a.type){var s=a.value;switch(s){case"top":n+="50% 0%";break;case"bottom":n+="50% 100%";break;case"left":n+="0% 50%";break;case"right":n+="100% 50%";break;case"center":n+="50% 50%";break;default:n+=s}}else n+="".concat(a.value).concat(a.type);return i&&(n+=" ".concat(i.value).concat(i.type)),n}if("directional"===e.type)switch(e.value){case"top":return"0deg";case"right":return"90deg";case"bottom":return"180deg";case"left":return"270deg";default:return"to ".concat(e.value)}return"".concat(e.value,"deg")}function stringifyGradient(r,e,t,o){if(void 0===e&&(e=!0),0===r.colorStops.length)return"white";var n=void 0!==o?o:r.orientation;n=n?n+", ":"";var a=r.colorStops.map((function(t,o){var n=t.length;if(e&&r.repeatData){var a=o;-1===r.repeatData.repeats&&(a=o<r.colorStops.length/2?0:1),n=r.repeatData.lengths[a]}return"".concat(t.color).concat(n?" "+n:"")}));e&&r.repeatData&&-1===r.repeatData.repeats&&(a.splice(0,1),a.splice(a.length-1,1));var i="";return r.position&&r.size&&(i="".concat(r.position,"/").concat(r.size," ")),"".concat(i).concat(t||r.type,"(").concat(n).concat(a.join(", "),")")}exports.expandGradient=expandGradient,exports.divideColorStops=divideColorStops,exports.verifiedExpandGradient=verifiedExpandGradient,exports.gradientFromAST=gradientFromAST,exports.parseGradient=parseGradient,exports.solidGradient=solidGradient,exports.parseSolidGradient=parseSolidGradient,exports.isStripesGradient=isStripesGradient,exports.normalizeGradientColorStop=normalizeGradientColorStop,exports.normalizeGradientOrientation=normalizeGradientOrientation,exports.stringifyGradient=stringifyGradient;