"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ComponentSchemaComputeHandler=exports.getRefFileName=exports.CODUX_PROPS_ANALYZER_TYPE_NAME=exports.CODUX_PROPS_ANALYZER_PREFIX=void 0;const tslib_1=require("tslib"),path_1=require("path"),typescript_schema_extract_1=require("@wixc3/typescript-schema-extract"),engine_resources_1=require("@wixc3/engine-resources"),universal_1=require("@wixc3/editor-commons/universal"),cross_performance_1=tslib_1.__importDefault(require("@wixc3/cross-performance")),engine_core_1=require("@wixc3/engine-core");exports.CODUX_PROPS_ANALYZER_PREFIX="/tmp_codux_props_analyzer_",exports.CODUX_PROPS_ANALYZER_TYPE_NAME="ResolvedProps";const getRefFileName=e=>e.includes("#")?e.split("#")[0]:null;exports.getRefFileName=getRefFileName;const importPropTypes='import type PropTypes from "prop-types";';class ComponentSchemaComputeHandler{constructor(e,t,n,s,r,o,a,i){this.fileManager=e,this.virtualFs=t,this.languageIntellisense=n,this.schemaService=s,this.pathPredicate=r,this.getProjectPath=o,this.getSymbolSchemas=(e,t)=>(cross_performance_1.default.mark("get-symbol-schemas"),this.schemaService.getSymbolSchemas(e,t)),this.debounceGetSymbolSchemas=new universal_1.Debouncer(this.getSymbolSchemas,a,i)}async compute(e){const{filePath:t,componentSymbolName:n}=e;cross_performance_1.default.mark("schema-extract-compute");const s=this.languageIntellisense.getLanguageController(t,this);let r=new Set([t]);const o=await this.getPropsSchema(t,n,s,r),a=this.getSymbol(t,s,n),i=await this.schemaService.getSymbolSchemas(t,a),p=await this.getDtsDependenciesPaths(t,n);r=new Set([...r,...i.dependencies,...p]);const c=new Set;return r.forEach((e=>{this.pathPredicate(e)&&c.add(this.fileManager.get(e))})),{value:{componentSchema:i,propsSchema:o},dependencies:c,status:{valid:!0}}}recompute(e,t,n,s){cross_performance_1.default.mark("schema-extract-recompute");const{filePath:r,componentSymbolName:o}=e.getId(),a=this.languageIntellisense.getLanguageController(r,this),i=this.getSymbol(r,a,o);return this.debounceGetSymbolSchemas.trigger(r,i).then((async t=>{const n=new Set([r,...t.dependencies]),s={componentSchema:t,propsSchema:await this.getPropsSchema(r,o,a,n)};e.isValid()&&e.applyChange((0,engine_resources_1.fullChange)(s))})).catch(engine_core_1.reportError),{changes:[],dependencies:s,status:(0,engine_resources_1.getDefaultStatusHandling)(e.getSerializedId(),s)}}async getDtsDependenciesPaths(e,t){const n=[],s=this.languageIntellisense.getLanguageController(e,this),r=(0,universal_1.getDTSPath)(e);if(s.filePaths.has(r)){const e=this.getSymbol(r,s,t),o=await this.schemaService.getSymbolSchemas(r,e);n.push(r),o.dependencies.forEach((e=>{this.pathPredicate(e)&&n.push(e)}))}return n}async getPropsSchema(e,t,n,s){var r,o,a;const i=`${exports.CODUX_PROPS_ANALYZER_PREFIX}${Math.random().toString()}.ts`,p=(0,path_1.join)(this.getProjectPath(),i),c=this.generateTempFileContent(p,e,t);this.virtualFs.writeFileSync(i,c),n.filePaths.add(p),"flushVersion"in n.serviceHost&&n.serviceHost.flushVersion();const m=this.getSymbol(p,n,exports.CODUX_PROPS_ANALYZER_TYPE_NAME);let l=null!==(r=this.schemaService.getTypeSchema(p,m,!0))&&void 0!==r?r:{};const h=new Map;if(l.$ref){const e=l.$ref,t=(0,exports.getRefFileName)(e);t&&(s.add(t),l=null!==(a=null===(o=await this.schemaService.getSchemaByReference(e,!0))||void 0===o?void 0:o.schema)&&void 0!==a?a:{},h.set(e,l))}return n.filePaths.delete(p),this.virtualFs.rmSync(i),l}generateTempFileContent(e,t,n){const s=(0,universal_1.rebaseRelativeModulePath)(e,t),r=(0,universal_1.replaceWinSlashes)((0,universal_1.getImportPath)(s)),o="default"===n?"TargetComponent":n;return`\n        ${"default"===n?`import ${o} from '${r}';`:`import { ${o} } from '${r}';`}\n\n        import type { ComponentType } from "react";\n        ${importPropTypes}\n\n     \n        type ComponentProps<\n            T extends keyof JSX.IntrinsicElements | ComponentType<any>\n        > = T extends ComponentType<infer P>\n            ? P\n            : T extends keyof JSX.IntrinsicElements\n            ? JSX.IntrinsicElements[T]\n            : {};\n      \n        type GetPropsFromPropTypes<\n            T extends keyof JSX.IntrinsicElements | ComponentType<any>\n        > = T extends ComponentType<any>\n            ? T["propTypes"] extends undefined\n            ? {}\n            : PropTypes.InferProps<T["propTypes"]>\n            : never;\n      \n        type IfAny<T, WhenTIsAny, WhenTIsNotAny> = 0 extends 1 & T ? WhenTIsAny : WhenTIsNotAny;\n\n        type TakeFirstLikeProps<T1, T2> = IfAny<T1, T2, T1>;\n        \n        /** \n         * There are two places we scan for props: \n         *  - types that are specified in ts and can be get with ComponentProps (ComponentType<infer P>)\n         *  - user defined propTypes from "prop-types" package inferred with GetPropsFromPropTypes (PropTypes.InferProps<T["propTypes"]>)\n         *    e.g. \n         *    MyComponent.propTypes = {\n         *         children: PropTypes.node.isRequired,\n         *         className: PropTypes.string,\n         *    }\n         * \n         *    Typescript types takes precedence over prop-types inferred types,\n         *    thus we take prop-types types only if typescript types props are resolved to any.\n         *    Type util TakeFirstLikeProps uses IfAny to test first generic type parameter for any and uses respective type as a result.\n         */\n\n        export type DetectedProps = TakeFirstLikeProps<\n            ComponentProps<typeof ${o}>,\n            GetPropsFromPropTypes<typeof ${o}>\n        >;\n        \n        export type ${exports.CODUX_PROPS_ANALYZER_TYPE_NAME} = Pick<DetectedProps, keyof DetectedProps>;\n    `}getSymbol(e,t,n){const s=t.languageService.getProgram();if(!s)throw new Error(`Can't get program for file ${e}`);const r=s.getSourceFile(e),o=s.getTypeChecker();if(!r)throw new Error(`Can't get sourceFile for file ${e}`);const a=this.findSymbol(n,r,o);if(!a)throw new Error(`No symbol found with a name ${n} in file ${e}`);return a}findSymbol(e,t,n){return(0,typescript_schema_extract_1.getExportedSymbols)(t,n).find((t=>t.name===e))}}exports.ComponentSchemaComputeHandler=ComponentSchemaComputeHandler;