"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.TsProvider=void 0;const tslib_1=require("tslib"),typescript_1=tslib_1.__importDefault(require("typescript")),universal_1=require("@wixc3/editor-commons/universal"),utils_1=require("./utils"),vscode_languageserver_types_1=require("vscode-languageserver-types"),{displayPartsToString:displayPartsToString,ScriptElementKind:tsKind}=typescript_1.default;class TsProvider{constructor(t,e){this.getLanguageController=t,this.config=e,this.completionTriggerChars=[".",'"',"'","`","/","@","<","#"," "],this.signatureHelpTriggerChars=["(",","],this.autoFormatTriggerCharacters=[";","}","\n"],this.getLanguageService=t=>{var e;return null===(e=this.getLanguageController(t,this,!1))||void 0===e?void 0:e.languageService}}supportsFileType(t){return t.endsWith(".ts")||t.endsWith(".tsx")}getCompletionItems(t,e){const n=this.getLanguageController(t,this,!1);if(!n)return[];const i=n.languageService.getCompletionsAtPosition(t,e,void 0);return i?i.entries.map((({name:t,kind:e,insertText:n,replacementSpan:i,sortText:s})=>({label:t,kind:(0,utils_1.tsKindToCompletionKind)(e),range:i&&{start:i.start,length:i.length},insertText:n||t,sortText:s}))):[]}getCompletionItemDetails(t,e,n){const i=this.getLanguageService(t);if(!i)return null;const s=i.getCompletionEntryDetails(t,e,n,void 0,void 0,void 0,void 0);return s?{detail:displayPartsToString(s.displayParts),documentation:displayPartsToString(s.documentation),label:s.name}:null}getSignatureHelp(t,e){const n=this.getLanguageService(t);if(!n)return;const i=n.getSignatureHelpItems(t,e,void 0);if(!i)return;const{items:s,selectedItemIndex:r,argumentIndex:a}=i,o={activeSignature:r,activeParameter:a,signatures:[]};for(const t of s){const{prefixDisplayParts:e,suffixDisplayParts:n,separatorDisplayParts:i,parameters:s}=t,r={label:displayPartsToString(e),documentation:void 0,parameters:[]};for(const[t,e]of s.entries()){const n=displayPartsToString(e.displayParts);r.label+=n,r.parameters.push({label:n,documentation:displayPartsToString(e.documentation)}),t<s.length-1&&(r.label+=displayPartsToString(i))}r.label+=displayPartsToString(n),o.signatures.push(r)}return o}getHoverInfo(t,e){const n=this.getLanguageService(t);if(!n)return;const i=n.getQuickInfoAtPosition(t,e);if(!i)return{contents:[]};const s=typescript_1.default.displayPartsToString(i.documentation),r=i.tags?i.tags.map((t=>{const e=`*@${t.name}*`;if(!t.text)return e;const n=typescript_1.default.displayPartsToString(t.text);return e+(n.match(/\r\n|\n/g)?" \n"+n:` - ${n}`)})).join("  \n\n"):"";return{contents:plainText("```typescript\n"+typescript_1.default.displayPartsToString(i.displayParts)+"\n```\n"+s+(r?"\n\n"+r:"")),range:this.tsRangeToLSP(n,t,i.textSpan)}}getDefinitions(t,e){const n=this.getLanguageService(t),i=null==n?void 0:n.getDefinitionAtPosition(t,e);if(i)return i.map((({fileName:t,textSpan:e})=>({uri:t,range:this.tsRangeToLSP(n,t,e)})))}tsRangeToLSP(t,e,n){return{start:t.toLineColumnOffset?t.toLineColumnOffset(e,n.start):{line:0,character:0},end:t.toLineColumnOffset?t.toLineColumnOffset(e,n.start+n.length):{line:0,character:0}}}lspRangeToTS(t,e,n){var i,s;const r=null===(s=null===(i=t.getProgram())||void 0===i?void 0:i.getSourceFile(e))||void 0===s?void 0:s.getFullText();return r?(0,universal_1.lspRangeToTS)(r,e,n):{start:0,length:0}}getDocumentHighlights(t,e){const n=this.getLanguageService(t),i=null==n?void 0:n.getOccurrencesAtPosition(t,e);if(i&&n)return i.map((({textSpan:t,isWriteAccess:e,fileName:i})=>({range:this.tsRangeToLSP(n,i,t),kind:e?vscode_languageserver_types_1.DocumentHighlightKind.Write:vscode_languageserver_types_1.DocumentHighlightKind.Text})))}getDocumentSymbols(t){const e=this.getLanguageService(t);if(!e)return[];return(e.getNavigationBarItems(t)||[]).map((n=>this.toDocumentSymbol(e,t,n)))}getReferences(t,e){const n=this.getLanguageService(t),i=null==n?void 0:n.getReferencesAtPosition(t,e);if(i)return i.map((t=>({uri:t.fileName,range:this.tsRangeToLSP(n,t.fileName,t.textSpan)})))}getRangeFormattingEdits(t,e,n){const i=this.getLanguageService(t),s=this.lspRangeToTS(i,t,e);return((null==i?void 0:i.getFormattingEditsForRange(t,s.start,s.start+s.length,(0,utils_1.formatOptionsToTsFormatting)(n,this.config.formatSettings)))||[]).map((({newText:e,span:n})=>({newText:e,range:this.tsRangeToLSP(i,t,n)})))}getOnTypeFormatting(t,e,n,i){const s=this.getLanguageService(t);return((null==s?void 0:s.getFormattingEditsAfterKeystroke(t,e,n,(0,utils_1.formatOptionsToTsFormatting)(i,this.config.formatSettings)))||[]).map((({newText:e,span:n})=>({newText:e,range:this.tsRangeToLSP(s,t,n)})))}getDiagnostics(t){const e=this.getLanguageService(t);return e?[...e.getSemanticDiagnostics(t),...e.getSyntacticDiagnostics(t)].filter((t=>void 0!==t.start&&void 0!==t.length)).map((({start:n=0,length:i=0,messageText:s,category:r})=>({range:this.tsRangeToLSP(e,t,{start:n,length:i}),severity:(0,utils_1.getDiagnosticSeverity)(r),message:typescript_1.default.flattenDiagnosticMessageText(s,"\n")}))):[{range:{start:{line:0,character:0},end:{line:0,character:0}},message:"File not found",severity:vscode_languageserver_types_1.DiagnosticSeverity.Error}]}tsKindToSymbolKind(t){const{Variable:e,Property:n,Function:i,Method:s,Enum:r,Module:a,Class:o,Interface:g}=vscode_languageserver_types_1.SymbolKind;switch(t){case tsKind.constElement:case tsKind.variableElement:case tsKind.localVariableElement:return e;case tsKind.memberVariableElement:case tsKind.memberGetAccessorElement:case tsKind.memberSetAccessorElement:return n;case tsKind.functionElement:case tsKind.localFunctionElement:return i;case tsKind.memberFunctionElement:return s;case tsKind.enumElement:return r;case tsKind.moduleElement:return a;case tsKind.classElement:return o;case tsKind.interfaceElement:return g}return e}toDocumentSymbol(t,e,n){const{text:i}=n,s=this.tsRangeToLSP(t,e,n.spans[0]);return{name:i,detail:"",kind:this.tsKindToSymbolKind(n.kind),range:s,selectionRange:s,children:n.childItems.map((n=>this.toDocumentSymbol(t,e,n)))}}}exports.TsProvider=TsProvider;const plainText=t=>({kind:"plaintext",value:t});